// PostMostView.cpp : implementation of the CPostMostView class
//

#include "stdafx.h"
#include "PostMost.h"

#include "PostMostDoc.h"
#include "PostMostView.h"

#include "MainFrm.h"

#include "PostingProgressDlg.h"

#include "PostMostPropertySheet.h"

#include "PropPage_Server.h"
#include "PropPage_Groups.h"
#include "PropPage_Headers.h"
#include "PropPage_ProgramSettings.h"

#include "TaskProp_FileAndParts.h"
#include "TaskProp_Groups.h"
#include "TaskProp_PrefixText.h"
#include "TaskProp_Log.h"

#include "HistoryDlg.h"
#include "AutoRetryDlg.h"

#include "DeleteTaskDlg.h"
#include "DelayedPostingDlg.h"

#include "PropPage_Add_Subject.h"
#include "PropPage_Add_Groups.h"
#include "PropPage_Add_TextPrefix.h"
#include "PropPage_Add_FileOrder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CPostMostView

IMPLEMENT_DYNCREATE(CPostMostView, CListView)

BEGIN_MESSAGE_MAP(CPostMostView, CListView)
	//{{AFX_MSG_MAP(CPostMostView)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI(ID_POST_THREADS, OnUpdatePostThreads)
	ON_COMMAND(ID_POST_THREADS, OnPostThreads)
	ON_UPDATE_COMMAND_UI(ID_POST_START, OnUpdatePostStart)
	ON_UPDATE_COMMAND_UI(ID_POST_STOP, OnUpdatePostStop)
	ON_COMMAND(ID_POST_STOP, OnPostStop)
	ON_COMMAND(ID_POST_START, OnPostStart)
	ON_UPDATE_COMMAND_UI(ID_POST_SETTINGS, OnUpdatePostSettings)
	ON_COMMAND(ID_POST_SETTINGS, OnPostSettings)
	ON_UPDATE_COMMAND_UI(ID_FILE_CLEARDONE, OnUpdateFileClearDoneFiles)
	ON_COMMAND(ID_FILE_CLEARDONE, OnFileClearDoneFiles)
	ON_UPDATE_COMMAND_UI(ID_FILE_CLEARLIST, OnUpdateFileClearList)
	ON_COMMAND(ID_FILE_CLEARLIST, OnFileClearList)
	ON_UPDATE_COMMAND_UI(ID_FILE_CLEAR_ERRORS, OnUpdateFileClearErrors)
	ON_COMMAND(ID_FILE_CLEAR_ERRORS, OnFileClearErrors)
	ON_UPDATE_COMMAND_UI(ID_FILE_QUEUE_ALL, OnUpdateFileQueueAll)
	ON_COMMAND(ID_FILE_QUEUE_ALL, OnFileQueueAll)
	ON_UPDATE_COMMAND_UI(ID_FILE_ADDFILES, OnUpdateFileAddFiles)
	ON_COMMAND(ID_FILE_ADDFILES, OnFileAddFiles)
	ON_UPDATE_COMMAND_UI(ID_FILE_CLEARSELECTED, OnUpdateFileClearSelected)
	ON_COMMAND(ID_FILE_CLEARSELECTED, OnFileClearSelected)
	ON_UPDATE_COMMAND_UI(ID_FILE_TASK_PROPERTIES, OnUpdateFileTaskProperties)
	ON_COMMAND(ID_FILE_TASK_PROPERTIES, OnFileTaskProperties)
	ON_UPDATE_COMMAND_UI(ID_FILE_HISTORY, OnUpdateFileHistory)
	ON_COMMAND(ID_FILE_HISTORY, OnFileHistory)
	ON_UPDATE_COMMAND_UI(ID_FILE_QUEUE_SEL, OnUpdateFileQueueSel)
	ON_COMMAND(ID_FILE_QUEUE_SEL, OnFileQueueSel)
	ON_WM_CONTEXTMENU()
	ON_UPDATE_COMMAND_UI(ID_FILE_REASSIGN_NEWSGROUPS, OnUpdateFileReassignNewsgroups)
	ON_COMMAND(ID_FILE_REASSIGN_NEWSGROUPS, OnFileReassignNewsgroups)
	ON_UPDATE_COMMAND_UI(ID_POST_START_AT, OnUpdatePostStartAt)
	ON_COMMAND(ID_POST_START_AT, OnPostStartAt)
	ON_WM_TIMER()
	ON_WM_CHAR()
	ON_UPDATE_COMMAND_UI(ID_MOVE_TASK_BOTTOM, OnUpdateMoveTaskBottom)
	ON_COMMAND(ID_MOVE_TASK_BOTTOM, OnMoveTaskBottom)
	ON_UPDATE_COMMAND_UI(ID_MOVE_TASK_DOWN, OnUpdateMoveTaskDown)
	ON_COMMAND(ID_MOVE_TASK_DOWN, OnMoveTaskDown)
	ON_UPDATE_COMMAND_UI(ID_MOVE_TASK_TOP, OnUpdateMoveTaskTop)
	ON_COMMAND(ID_MOVE_TASK_TOP, OnMoveTaskTop)
	ON_UPDATE_COMMAND_UI(ID_MOVE_TASK_UP, OnUpdateMoveTaskUp)
	ON_COMMAND(ID_MOVE_TASK_UP, OnMoveTaskUp)
	ON_NOTIFY_REFLECT(LVN_KEYDOWN, OnKeydown)
	ON_UPDATE_COMMAND_UI(ID_FILE_SET_HOLD, OnUpdateFileSetHold)
	ON_COMMAND(ID_FILE_SET_HOLD, OnFileSetHold)
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_FILES, OnUpdateIndicatorFiles)
	ON_MESSAGE(WM_FILES_DROPPED, OnFilesDropped)
	ON_MESSAGE(WM_THREAD_READY,  OnThread_Ready)
	ON_MESSAGE(WM_THREAD_NO_CONNECTION, OnThread_NoConnection)
	ON_MESSAGE(WM_THREAD_SERVER_NOT_READY, OnThread_ServerNotReady)
	ON_MESSAGE(WM_THREAD_UPDATE_PROGRESS, OnThread_UpdateProgress)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPostMostView construction/destruction
CLIPFORMAT CPostMostView::m_cfObjectDescriptor = NULL;

CPostMostView::CPostMostView()
{
	m_bRunning = FALSE;
	m_bWaiting = FALSE;
	m_nWaitTimerID = 0;

	m_pProgressDlg = (CPostingProgressDlg*) NULL;

	// Initialize Drag & Drop Support
	m_bInDrag = FALSE;
	m_prevDropEffect = DROPEFFECT_NONE;
	// Drag & Drop Support
	m_cfObjectDescriptor = (CLIPFORMAT) ::RegisterClipboardFormat(_T("Object Descriptor"));
	m_bPostStopNoSound = FALSE;
}

CPostMostView::~CPostMostView()
{
}

BOOL CPostMostView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CListView::PreCreateWindow(cs);
}


void CPostMostView::OnInitialUpdate()
{
	CListView::OnInitialUpdate();

	// Load Program Settings
	m_Settings.LoadFromRegistry();

	if(m_Settings.m_bSysTrayIcon == TRUE)
		((CMainFrame*) AfxGetApp()->m_pMainWnd)->NotifyIcon(NIM_ADD, IDI_ICON_TRAY_READY);

	// Set image lists for list control
	CListCtrl& listCtrl = GetListCtrl();
	listCtrl.SetImageList(&((CPostMostApp*) AfxGetApp())->m_ImageList, LVSIL_SMALL);

	// Get Window Stule from Registry
	listCtrl.ModifyStyle(LVS_TYPEMASK, LVS_REPORT);
	listCtrl.ModifyStyle(0, LVS_SHOWSELALWAYS);

	m_Windows_View_Color_BkColor = listCtrl.GetBkColor();
	m_Windows_View_Color_TextColor = listCtrl.GetTextColor();
	m_Windows_View_Color_TextBkColor = listCtrl.GetTextBkColor();

	SetListControlColors();

	// Create Report columns
	listCtrl.InsertColumn(0, "Article Subject Line", LVCFMT_LEFT, m_Settings.m_nViewColWid[0], -1);
	listCtrl.InsertColumn(1, "Parts To Post", LVCFMT_LEFT, m_Settings.m_nViewColWid[1], -1);
	listCtrl.InsertColumn(2, "Posting Result", LVCFMT_LEFT, m_Settings.m_nViewColWid[2], -1);
	listCtrl.InsertColumn(3, "Newsgroups", LVCFMT_LEFT, m_Settings.m_nViewColWid[3], -1);

	LoadTasksFromQueue();

	StartWaitTimer();

	if(m_Settings.m_bSound) PlaySound((LPCTSTR) IDR_WAVE_LAUGH, NULL, SND_RESOURCE | SND_ASYNC);
}

void CPostMostView::SetListControlColors()
{
	CListCtrl& listCtrl = GetListCtrl();

	if(m_Settings.m_bDefaultListViewColors == TRUE)
	{
		listCtrl.SetBkColor(m_Windows_View_Color_BkColor);
		listCtrl.SetTextColor(m_Windows_View_Color_TextColor);
		listCtrl.SetTextBkColor(m_Windows_View_Color_TextBkColor);
	}
	else
	{
		listCtrl.SetBkColor(RGB(0,0,0));
		listCtrl.SetTextColor(RGB(0, 255, 0));
		listCtrl.SetTextBkColor(RGB(0, 0, 0));
	}
}

void CPostMostView::SaveColumnWidthsToSettings()
{
	CListCtrl& listCtrl = GetListCtrl();

	for(int k = 0; k < 4; k++)
	{
		m_Settings.m_nViewColWid[k] = listCtrl.GetColumnWidth(k);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPostMostView diagnostics

#ifdef _DEBUG
void CPostMostView::AssertValid() const
{
	CListView::AssertValid();
}

void CPostMostView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}

CPostMostDoc* CPostMostView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPostMostDoc)));
	return (CPostMostDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPostMostView message handlers

int CPostMostView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CListView::OnCreate(lpCreateStruct) == -1)
		return -1;

	DragAcceptFiles(TRUE);

	if(!m_DropTarget.Register(this))
		AfxMessageBox("Error Enabling Window As A Drag & Drop Target");
			
	return 0;
}

DROPEFFECT CPostMostView::OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point) 
{
	ASSERT(m_prevDropEffect == DROPEFFECT_NONE);
	TRACE("OnDragEnter()\n");
	
	m_dragSize = CSize(0,0);
	m_dragOffset = CSize(0,0);
	HGLOBAL hObjDesc = pDataObject->GetGlobalData(m_cfObjectDescriptor);
	if(hObjDesc != NULL)
	{
		LPOBJECTDESCRIPTOR pObjDesc = (LPOBJECTDESCRIPTOR) ::GlobalLock(hObjDesc);
		ASSERT(pObjDesc != NULL);
		m_dragSize.cx = (int) pObjDesc->sizel.cx;
		m_dragSize.cy = (int) pObjDesc->sizel.cy;
		m_dragOffset.cx = (int) pObjDesc->pointl.x;
		m_dragOffset.cy = (int) pObjDesc->pointl.y;
		::GlobalUnlock(hObjDesc);
		::GlobalFree(hObjDesc);
	}
	CClientDC dc(NULL);
	dc.HIMETRICtoDP(&m_dragSize);
	dc.HIMETRICtoDP(&m_dragOffset);
	m_dragPoint = point - CSize(1,1);
	return CListView::OnDragOver(pDataObject, dwKeyState, point);

	// return CListView::OnDragEnter(pDataObject, dwKeyState, point);
}

DROPEFFECT CPostMostView::OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point) 
{
	// TRACE("OnDragOver()\n");
	DROPEFFECT de = DROPEFFECT_NONE;
	point -= m_dragOffset;
	if(point == m_dragPoint)
		return DROPEFFECT_COPY;
	CClientDC dc(this);
	if(m_prevDropEffect != DROPEFFECT_NONE)
		dc.DrawFocusRect(CRect(m_dragPoint, m_dragSize));
	m_prevDropEffect = DROPEFFECT_COPY;
	if(m_prevDropEffect != DROPEFFECT_NONE)
	{
		m_dragPoint = point;
		dc.DrawFocusRect(CRect(m_dragPoint, m_dragSize));
	}
	return DROPEFFECT_COPY;
	// return CListView::OnDragOver(pDataObject, dwKeyState, point);
}

void CPostMostView::OnDragLeave() 
{
	// TODO: Add your specialized code here and/or call the base class
	CClientDC dc(this);
	if(m_prevDropEffect != DROPEFFECT_NONE)
	{
		dc.DrawFocusRect(CRect(m_dragPoint, m_dragSize));
		m_prevDropEffect = DROPEFFECT_NONE;
	}
	TRACE("OnDragLeave()\n");
	// CListView::OnDragLeave();
}

BOOL CPostMostView::OnDrop(COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point) 
{
	ASSERT_VALID(this);
	OnDragLeave();

	TRACE("OnDragDrop()\n");

	STGMEDIUM StgMedium;
	::ZeroMemory(&StgMedium, sizeof(STGMEDIUM));

	UINT kk;
	TCHAR szFilename[_MAX_PATH + 1];

	m_Dropped_Files.RemoveAll();

	if(pDataObject->GetData(CF_HDROP, &StgMedium) == TRUE)
	{
		TRACE1("GetData(CF_HDROP. &STGMEDIUM) Succeeded - tymed = %d\n", StgMedium.tymed);
		if(StgMedium.tymed == TYMED_HGLOBAL)
		{
			HDROP hDrop = (HDROP) ::GlobalLock(StgMedium.hGlobal);
			if(hDrop != (HDROP) NULL)
			{
				UINT nFiles = DragQueryFile(hDrop, (UINT) -1, NULL, 0);
				TRACE1("There were %d file(s) dropped.\n", nFiles);
				for(kk = 0; kk < nFiles; kk++)
				{
					::ZeroMemory(szFilename, _MAX_PATH + 1);
					DragQueryFile(hDrop, kk, (LPTSTR) szFilename, _MAX_PATH + 1);
					if(m_Settings.m_bSortFilesOnAdd)
						::CM_CSA_INSERT(m_Dropped_Files, szFilename);
					else
						m_Dropped_Files.Add((LPCTSTR) szFilename);
					TRACE1("Filename Dropped: %s\n", szFilename);
				}
				::GlobalUnlock(StgMedium.hGlobal);
				::GlobalFree(StgMedium.hGlobal);
			}
		}
		ReleaseStgMedium(&StgMedium);

		PostMessage(WM_FILES_DROPPED);
	}
	else AfxMessageBox("Invalid Format For Drag & Drop Operation.", MB_ICONEXCLAMATION);

	TRACE("CPostMostView::OnDrop() - RETURNING\n");
	return TRUE;
	// return CListView::OnDrop(pDataObject, dropEffect, point);
}

afx_msg LRESULT CPostMostView::OnFilesDropped(WPARAM wParam, LPARAM lParam)
{
	TRACE("CPostMostView::OnFilesDropped() - |m_Dropped_Files| = %d\n", m_Dropped_Files.GetSize());

	CString strSubjectPrefixTemplate;

	BOOL bInsertFilesAtBeginningOfQueue = FALSE;
	BOOL bProcessDir = TRUE;
	BOOL bProcessDirRecursive = FALSE;
	BOOL bCountDirSeperate = FALSE;
	BOOL bAddPrefixText = FALSE;
	BOOL bAddPrefixTextFirstFileOnly = FALSE;

	AfxGetApp()->m_pMainWnd->SetForegroundWindow();

	if(m_Settings.m_bSound) PlaySound((LPCTSTR) IDR_WAVE_YEAH, NULL, SND_ASYNC | SND_RESOURCE | SND_NOSTOP);

	int kk;
	int nItem;

	CFileStatus fStatus;
	CListCtrl& listCtrl = GetListCtrl();
	CString sz_theDirectory, sz_theFile;
	CStringArray listFileNames, listDir;
	int nDirectories = 0;

	if(TRUE)
	{
		CWaitCursor wc;
		// Seperate the files from the directories
		for(kk = 0; kk < m_Dropped_Files.GetSize(); kk++)
		{
			if(CFile::GetStatus((LPCTSTR) m_Dropped_Files.GetAt(kk), fStatus))
			{
				if(fStatus.m_attribute & 0x10)
					listDir.Add(m_Dropped_Files.GetAt(kk));
				else
					listFileNames.Add(m_Dropped_Files.GetAt(kk));
			}
		}

		nDirectories = listDir.GetSize();
	}

	// Done with original list - clear it up..
	m_Dropped_Files.RemoveAll();

	CPropPage_Add_Subject		PP_Subject;
	CPropPage_Add_Groups		PP_Groups;
	CPropPage_Add_TextPrefix	PP_TextPrefix;
	CPropPage_Add_FileOrder     PP_FileOrder;

	DWORD dwPageActivation = 0;
	PP_Subject.m_pdwActivation = &dwPageActivation;
	PP_Groups.m_pdwActivation = &dwPageActivation;
	PP_TextPrefix.m_pdwActivation = &dwPageActivation;
	PP_FileOrder.m_pdwActivation = &dwPageActivation;

	PP_Subject.m_bSound = m_Settings.m_bSound;
	PP_Subject.m_nDir   = nDirectories;
	PP_Subject.m_pDroppedFiles = &listFileNames;
	PP_Subject.m_bInsertFilesAtBeginningOfQueue = bInsertFilesAtBeginningOfQueue;
	PP_Subject.m_bProcessSubdirectories = bProcessDir;
	PP_Subject.m_bRecursive = bProcessDirRecursive;
	PP_Subject.m_bCountDirSeperate = bCountDirSeperate;
	PP_Subject.m_strSubjectPrefixTemplate = (LPCTSTR) m_Settings.m_szLastSubjectTemplate;

	PP_Groups.m_bSound = m_Settings.m_bSound;
	PP_Groups.m_pSettings = &m_Settings;

	PP_TextPrefix.m_bSound = m_Settings.m_bSound;

	PP_FileOrder.m_bSound = m_Settings.m_bSound;
	PP_FileOrder.m_pDWA_FileNames = &listFileNames;

	TCHAR szPSTitle[64];
	if(listDir.GetSize() > 0)
	{
		if(listFileNames.GetSize() > 0)
			sprintf(szPSTitle, "Add %d File%s %d Directories", 
			listFileNames.GetSize(), 
			(listFileNames.GetSize() == 1) ? "," : "s,",
			listDir.GetSize());
		else
			sprintf(szPSTitle, "Add %d Director%s", 
			listDir.GetSize(),
			(listDir.GetSize() == 1) ? "y" : "ies" );
	}
	else
	{
		if(listFileNames.GetSize() > 0)
			sprintf(szPSTitle, "Add %d File%s", listFileNames.GetSize(),
			(listFileNames.GetSize() == 1) ? "" : "s");
		else
		{
			AfxMessageBox("No Files To Add!", MB_ICONINFORMATION);
			return(0);
		}
	}

	CPropertySheet PS;
	PS.SetTitle(szPSTitle);
	PS.AddPage(&PP_Subject);
	PS.AddPage(&PP_Groups);
	PS.AddPage(&PP_TextPrefix);
	
	if((listFileNames.GetSize() > 0) && (listDir.GetSize() == 0))
		PS.AddPage(&PP_FileOrder);

	PS.m_psh.dwFlags |= PSH_NOAPPLYNOW;

	// Setup Example with something real if we can...
	if(listFileNames.GetSize() > 1)
	{
		// strcpy(PP_Subject.m_Ex_szFilename, (LPCTSTR) listFileNames.GetAt(0));
		PP_Subject.m_Ex_nFileCount = listFileNames.GetSize();
	}

	if(PS.DoModal() == IDCANCEL)
	{
		if(m_Settings.m_bSound) PlaySound((LPCTSTR) IDR_WAVE_VAULT, NULL, SND_ASYNC | SND_RESOURCE | SND_NOSTOP);
		return(0);
	}

	strcpy(m_Settings.m_szLastSubjectTemplate, (LPCTSTR) PP_Subject.m_strSubjectPrefixTemplate);

	if(m_Settings.m_bSound)
		PlaySound((LPCTSTR) IDR_WAVE_GROOVY, NULL, SND_ASYNC | SND_RESOURCE | SND_NOSTOP);

	strSubjectPrefixTemplate = (LPCTSTR) PP_Subject.m_strSubjectPrefixTemplate;
	bInsertFilesAtBeginningOfQueue = PP_Subject.m_bInsertFilesAtBeginningOfQueue;
	bProcessDir = PP_Subject.m_bProcessSubdirectories;
	bProcessDirRecursive = PP_Subject.m_bRecursive;
	bCountDirSeperate = PP_Subject.m_bCountDirSeperate;

	LPCTSTR lpszTextPrefix = (LPCTSTR) PP_TextPrefix.m_strTextPrefix;
	bAddPrefixText = PP_TextPrefix.m_bSendTextPrefix;
	bAddPrefixTextFirstFileOnly = PP_TextPrefix.m_bSendTextFirstFileOnly;
	LPCTSTR lpszGroupList = (LPCTSTR) PP_Groups.m_strGroupList;

	// Process Directories
	int nInsertPoint;
	char szCurFilename[_MAX_PATH+1];
	char szLastDir[_MAX_PATH+1];
	char szCurDir[_MAX_PATH+1];
	char szCurFile[_MAX_PATH+1];

	if(TRUE)
	{
		CWaitCursor wc;

		if(bProcessDir)
		{
			for(kk = 0; kk < listDir.GetSize(); kk++)
			{	
				GetDirectoryFiles(listFileNames, (LPCTSTR) listDir.GetAt(kk), bProcessDirRecursive);
			}
		}

		nItem = listCtrl.GetItemCount();
		
		// Now Process The Files...
		int kAdded = 0;
		if(bCountDirSeperate == TRUE)
		{
			// Number each file by directory
			CStringArray tempList;

			while(listFileNames.GetSize() > 0)
			{
				// Move first item and set the current directory
				tempList.RemoveAll();
				strcpy(szCurFilename, (LPCTSTR) listFileNames.GetAt(0));
				_BreakFilename((LPCTSTR) listFileNames.GetAt(0), szCurDir, szCurFile);
				strcpy(szLastDir, szCurDir);
				listFileNames.RemoveAt(0);
				tempList.Add(szCurFilename);
				while(listFileNames.GetSize() > 0)
				{
					strcpy(szCurFilename, (LPCTSTR) listFileNames.GetAt(0));
					_BreakFilename((LPCTSTR) listFileNames.GetAt(0), szCurDir, szCurFile);
					if(strcmp(szCurDir, szLastDir) == 0)
					{
						listFileNames.RemoveAt(0);
						tempList.Add(szCurFilename);
					}
					else break;
				}
				// Add Items in tempList
				for(kk = 0; kk < tempList.GetSize(); kk++)
				{	
					if(bInsertFilesAtBeginningOfQueue)
						nInsertPoint = kAdded;
					else
						nInsertPoint = nItem + kAdded;

					if(bAddPrefixText)
					{
						if(bAddPrefixTextFirstFileOnly)
						{
							if(kAdded == 0)
								InsertFileIntoQueue((LPCTSTR) tempList.GetAt(kk), (LPCTSTR) strSubjectPrefixTemplate, nInsertPoint, kk+1, tempList.GetSize(), lpszTextPrefix, lpszGroupList);
							else
								InsertFileIntoQueue((LPCTSTR) tempList.GetAt(kk), (LPCTSTR) strSubjectPrefixTemplate, nInsertPoint, kk+1, tempList.GetSize(), NULL, lpszGroupList);
						}
						else
							InsertFileIntoQueue((LPCTSTR) tempList.GetAt(kk), (LPCTSTR) strSubjectPrefixTemplate, nInsertPoint, kk+1, tempList.GetSize(), lpszTextPrefix, lpszGroupList);
					}
					else
						InsertFileIntoQueue((LPCTSTR) tempList.GetAt(kk), (LPCTSTR) strSubjectPrefixTemplate, nInsertPoint, kk+1, tempList.GetSize(), NULL, lpszGroupList);
					
					++kAdded;
				}

			}

		}
		else
		{
			// Number them all as one batch
			for(kk = 0; kk < listFileNames.GetSize(); kk++)
			{	
				// Determine point in list to insert new item
				if(bInsertFilesAtBeginningOfQueue)
					nInsertPoint = kk;
				else
					nInsertPoint = nItem + kk;

					if(bAddPrefixText)
					{
						if(bAddPrefixTextFirstFileOnly)
						{
							if(kk == 0)
								InsertFileIntoQueue((LPCTSTR) listFileNames.GetAt(kk), (LPCTSTR) strSubjectPrefixTemplate, nInsertPoint, kk+1, listFileNames.GetSize(), lpszTextPrefix, lpszGroupList);
							else
								InsertFileIntoQueue((LPCTSTR) listFileNames.GetAt(kk), (LPCTSTR) strSubjectPrefixTemplate, nInsertPoint, kk+1, listFileNames.GetSize(), NULL, lpszGroupList);
						}
						else
							InsertFileIntoQueue((LPCTSTR) listFileNames.GetAt(kk), (LPCTSTR) strSubjectPrefixTemplate, nInsertPoint, kk+1, listFileNames.GetSize(), lpszTextPrefix, lpszGroupList);
					}
					else
						InsertFileIntoQueue((LPCTSTR) listFileNames.GetAt(kk), (LPCTSTR) strSubjectPrefixTemplate, nInsertPoint, kk+1, listFileNames.GetSize(), NULL, lpszGroupList);
			}
		}
	}

	// Done
	listFileNames.RemoveAll();
	listDir.RemoveAll();
	return((LRESULT) 0);
}

void CPostMostView::InsertFileIntoQueue(LPCTSTR szFilename, LPCTSTR szSubjectPrefixTemplate, int nInsertAt, int nCountValue, int nTotalCount, LPCTSTR szTextPrefix, LPCTSTR szGroupList)
{
	char szFileSubject[1024];

	TCHAR sz_theDirectory[_MAX_PATH];
	TCHAR sz_theFile[_MAX_PATH];

	// Get base filename of current file
	_BreakFilename(szFilename, sz_theDirectory, sz_theFile);

	CFileStatus rFileStatus;
	CFile::GetStatus(szFilename, rFileStatus);

	TRACE2("Adding '%s' -- Size = %u\n", szFilename, rFileStatus.m_size);

	// TODO: Only include last directory name
	::CM_BuildSubjectFromTemplate(szSubjectPrefixTemplate, sz_theDirectory, sz_theFile, rFileStatus.m_size, nCountValue, nTotalCount, szFileSubject);

	CTaskObject* pTaskObject = new CTaskObject;

	pTaskObject->Reset();
	
	pTaskObject->m_nState = CTaskObject::PM_QUEUED;

	pTaskObject->m_strGroups = szGroupList;

	if(szTextPrefix != NULL)
		pTaskObject->m_strTextPrefix = szTextPrefix;

	if(pTaskObject->m_strTextPrefix.GetLength() > 0)
		pTaskObject->m_bPostPrefixText = TRUE;
	else
		pTaskObject->m_bPostPrefixText = FALSE;

	strcpy(pTaskObject->m_szFilename, szFilename);

	strcpy(pTaskObject->m_szSubject, szFileSubject);

	pTaskObject->m_nMaxLines = m_Settings.m_nMaxLines;

	pTaskObject->m_dwFileSize = rFileStatus.m_size;

	int nParts = CM_CalcNumberOfParts(pTaskObject->m_dwFileSize, pTaskObject->m_nMaxLines);

	pTaskObject->m_dwaPartsToPost.SetSize(0, nParts);

	for(int k = 1; k <= nParts; k++)
	{
		pTaskObject->m_dwaPartsToPost.Add(k);
	}

	TCHAR szPartCount[32];
	sprintf(szPartCount, "%d/%d", pTaskObject->m_dwaPartsToPost.GetSize(), nParts);
	if(pTaskObject->m_bPostPrefixText == TRUE)
		strcat(szPartCount, "+0");

	CListCtrl& listCtrl = GetListCtrl();
	listCtrl.InsertItem(nInsertAt, szFileSubject, 0);			// Subject Lines
	listCtrl.SetItemText(nInsertAt, 1, szPartCount);			// Computed Number Of Parts
	listCtrl.SetItemText(nInsertAt, 3, (LPCTSTR) pTaskObject->m_strGroups);
	listCtrl.SetItemData(nInsertAt, (DWORD) pTaskObject);		// Pointer To Task Object
}

void CPostMostView::GetDirectoryFiles(CStringArray& FileList, LPCTSTR szDirectory, BOOL bRecursive)
{
	char szPath[_MAX_PATH + 1];

	CString szFileFound;
	CFileFind finder;
	CFileStatus fStatus;
	BOOL      bFound;

	sprintf(szPath, szDirectory);
	strcat(szPath, "\\*.*");

	TRACE1("Processing Directory: '%s'\n", szDirectory);

	// (1) Process Files
	bFound = finder.FindFile(szPath);
	while(bFound)
	{
		bFound = finder.FindNextFile();
		szFileFound = finder.GetFilePath();
		try
		{
			if(CFile::GetStatus((LPCTSTR) szFileFound, fStatus))
			{
				if((fStatus.m_attribute & 0x10) == 0x00)
				{
					FileList.Add(szFileFound);
				}
			}
		}
		catch (CException* e)
		{
			e->Delete();
		}
	}

	// (2) Process Subdirectories
	if(bRecursive)
	{
		bFound = finder.FindFile(szPath);
		while(bFound)
		{
			bFound = finder.FindNextFile();
			szFileFound = finder.GetFileName();
			if(szFileFound.Compare(".") == 0) continue;
			if(szFileFound.Compare("..") == 0) continue;
			szFileFound = finder.GetFilePath();
			if(CFile::GetStatus((LPCTSTR) szFileFound, fStatus))
			{
				if(fStatus.m_attribute & 0x10)
					GetDirectoryFiles(FileList, szFileFound, bRecursive);
			}
		}
	}
}


void CPostMostView::_BreakFilename(LPCTSTR FullFilename, CString& Path, CString& File)
{
	int kk;
	int sz = strlen(FullFilename);

	Path.Empty();
	File.Empty();

	for(kk = (sz-1); kk >= 0; kk--)
		if(FullFilename[kk] == '\\') break;
	if(kk < 0)
	{
		File = FullFilename;
		return;
	}
	
	CString FullName = FullFilename;
	if(kk > 0)		Path = FullName.Left(kk+1);
	if(kk < (sz-1)) File = FullName.Right((sz-1) - kk);
	return;
}

void CPostMostView::_BreakFilename(LPCTSTR FullFilename, char* szDir, char* szFile)
{
	int sl;
	strcpy(szDir, FullFilename);
	sl = strlen(szDir) - 1;
	while((sl > 0) && (szDir[sl] != '\\')) --sl;
	szDir[sl] = '\0';
	strcpy(szFile, &szDir[sl+1]);
}

void CPostMostView::OnUpdatePostThreads(CCmdUI* pCmdUI) 
{
	if(m_bWaiting == TRUE)
	{
		pCmdUI->Enable(FALSE);
		pCmdUI->SetCheck(0);
		return;
	}

	pCmdUI->Enable(m_bRunning);
	if(m_bRunning)
	{
		if(m_pProgressDlg != (CPostingProgressDlg*) NULL)
			pCmdUI->SetCheck(1);
		else
			pCmdUI->SetCheck(0);
	}
	else pCmdUI->SetCheck(0);

}

void CPostMostView::OnPostThreads() 
{
	RECT rectProgressButton;
	CMainFrame* pMainFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	pMainFrame->GetProgressDlgButtonRect(&rectProgressButton);

	if(m_pProgressDlg == (CPostingProgressDlg*) NULL)
	{
		m_pProgressDlg = new CPostingProgressDlg(this);
		m_pProgressDlg->m_rectAnimateFrom = rectProgressButton;
		m_pProgressDlg->m_pView = this;
		if(!m_pProgressDlg->Create(IDD_DIALOG_PROGRESS, this))
		{
			delete m_pProgressDlg;
			AfxMessageBox("Error Creating Progress Window!", MB_ICONSTOP);
			return;
		}
		m_pProgressDlg->SetActiveWindow();
	}
	else
	{
	}
}

void CPostMostView::OnUpdatePostStart(CCmdUI* pCmdUI) 
{
	if(m_bRunning)
		pCmdUI->Enable(FALSE);
	else
	{
		if(GetListCtrl().GetItemCount() == 0)
			pCmdUI->Enable(FALSE);
		else
		{
			pCmdUI->Enable(__FilesInQueue_Q());
		}
	}
}

void CPostMostView::OnUpdatePostStop(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bRunning);	
}

void CPostMostView::OnPostStop() 
{
	CMainFrame* pMainFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	if(m_bWaiting == TRUE)
	{
		m_bWaiting = FALSE;
		m_bRunning = FALSE;

		// Update Tray Icon
		((CMainFrame*) AfxGetApp()->m_pMainWnd)->NotifyIcon(NIM_MODIFY, IDI_ICON_TRAY_READY);

		pMainFrame->SetProgressIndicator("");
		return;
	}

	// Update Tray Icon
	pMainFrame->NotifyIcon(NIM_MODIFY, IDI_ICON_TRAY_READY);

	if(m_bPostStopNoSound == FALSE)
	{
		if(m_Settings.m_bSound)
		{
			PlaySound((LPCTSTR) IDR_WAVE_REPRESS, NULL, SND_RESOURCE | SND_ASYNC);
			::Sleep(400);
		}
		if(AfxMessageBox("Posting In Progress!\n\nStop Running?", MB_ICONEXCLAMATION | MB_OKCANCEL) == IDCANCEL)
			return;
	}

	CWaitCursor wc;
	if(m_pProgressDlg != NULL)
	{
		m_pProgressDlg->SendMessage(WM_CLOSE);
		delete m_pProgressDlg;
		m_pProgressDlg = NULL;
	}

	if(!m_ThreadMarshal.Stop_Thread())
	{
		if(m_bPostStopNoSound == FALSE)
			AfxMessageBox("Error Stopping Poster Thread!", MB_ICONSTOP);
		return;
	}

	// Turn any 'P' images into 'Q' images..
	int kk;
	CListCtrl& theList = GetListCtrl();
	int nItems = theList.GetItemCount();
	LVITEM theItem;
	::ZeroMemory(&theItem, sizeof(LVITEM));
	theItem.mask = LVIF_IMAGE;
	CTaskObject* pTaskObject;

	// If we just posted one, set the image/state back to QUEUE
	for(kk = 0; kk < nItems; kk++)
	{
		theItem.iItem = kk;
		theList.GetItem(&theItem);

		if(theItem.iImage == IMAGE_POSTING)	// 1
		{
			theItem.iImage = IMAGE_QUEUE;	// 0
			theList.SetItem(&theItem);
			TRACE1("Reverting Item %d From P to Q\n", kk);
			pTaskObject = (CTaskObject*) theList.GetItemData(kk);
			pTaskObject->m_nState = CTaskObject::PM_QUEUED;
			UpdatePartsDisplay(kk, pTaskObject);
			break;
		}
	}


	if(m_bPostStopNoSound == FALSE)
	{
		if((m_Settings.m_bSound == TRUE) && (m_bPostStopNoSound == FALSE))
			PlaySound((LPCTSTR) IDR_WAVE_SKIDCRASH, NULL, SND_RESOURCE | SND_ASYNC);
	}

	pMainFrame->SetProgressIndicator("");

	m_bRunning = FALSE;
	
	SaveTasksToQueue();
}

void CPostMostView::OnPostStart()
{
	CWaitCursor wc;

	CListCtrl& list = GetListCtrl();

	if(list.GetItemCount() == 0)
	{
		AfxMessageBox("No Files Queued For Posting!", MB_ICONSTOP);
		return;
	}

	m_ThreadMarshal.SetProgramSettings(m_Settings);

	// Compute entire batch size
	m_ThreadMarshal.SetBatchSize(__ComputeBatchSize());

	if(!m_ThreadMarshal.Start_Thread(m_hWnd))
	{
		AfxMessageBox("Error Starting Poster Thread!", MB_ICONSTOP);
		return;
	}

	m_bRunning = TRUE;
	
	// Update Tray Icon
	((CMainFrame*) AfxGetApp()->m_pMainWnd)->NotifyIcon(NIM_MODIFY, IDI_ICON_TRAY_POSTING);

	if(m_Settings.m_bSound)
	{
		switch(::GetTickCount() % 2)
		{
		case 0:
			PlaySound((LPCTSTR) IDR_WAVE_NOWGO, NULL, SND_RESOURCE | SND_ASYNC);
			break;
		case 1:
			PlaySound((LPCTSTR) IDR_WAVE_ALLSYSGO, NULL, SND_RESOURCE | SND_ASYNC);
			break;
		}
	}

	m_Time_Started = CTime::GetCurrentTime();

	if(m_Settings.m_bShowProgressDialogOnStart && (m_pProgressDlg == NULL))
		OnPostThreads();

}

void CPostMostView::OnUpdatePostSettings(CCmdUI* pCmdUI)
{
	if(m_bRunning)
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);
}

void CPostMostView::OnPostSettings() 
{
	RECT rectButton;
	CMainFrame* pMainFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	pMainFrame->GetPropertiesButtonRect(&rectButton);

	CProgramSettings CurrentProgramSettings;
	CurrentProgramSettings.Copy(m_Settings);

	CPostMostPropertySheet PS("Properties for YENC-POWER-POST");
	PS.m_rectAnimateFrom = rectButton;

	CPropPage_Server  PP_Server;	
		PP_Server.m_pSettings = &CurrentProgramSettings;
		PP_Server.m_pSettings_ApplyTo = &m_Settings;

	CPropPage_Headers PP_Headers;	
		PP_Headers.m_pSettings = &CurrentProgramSettings;
		PP_Headers.m_pSettings_ApplyTo = &m_Settings;

	CPropPage_Groups  PP_Groups;	
		PP_Groups.m_pSettings = &CurrentProgramSettings;
		PP_Groups.m_pSettings_ApplyTo = &m_Settings;

	CPropPage_ProgramSettings PP_Program;
		PP_Program.m_pSettings = &CurrentProgramSettings;
		PP_Program.m_pSettings_ApplyTo = &m_Settings;

	PS.AddPage(&PP_Server);
	PS.AddPage(&PP_Headers);
	PS.AddPage(&PP_Groups);
	PS.AddPage(&PP_Program);

	PS.DoModal();

	if(m_Settings.m_bSound) PlaySound((LPCTSTR) IDR_WAVE_SHUT, NULL, SND_ASYNC | SND_RESOURCE);
	m_Settings.SaveToRegistry();

}

LRESULT CPostMostView::OnThread_UpdateProgress(WPARAM wParam, LPARAM lParam)
{
	CMainFrame* pMainFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;

	TCHAR szArticle[320];
	int nPart, nPartOf;

	m_ThreadMarshal.GetCurrentArticleStatus(szArticle, &nPart, &nPartOf);

	TCHAR szText[64];
	
	CM_BuildArticleName(szText, "Posting Part", "", nPart, nPartOf);

	pMainFrame->SetProgressIndicator(szText);

	return(0);
}

LRESULT CPostMostView::OnThread_NoConnection(WPARAM wParam, LPARAM lParam)
{
	CMainFrame* pMainFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	pMainFrame->SetProgressIndicator("");

	BOOL bResult_OK = FALSE;
	char szResult[1024];

	sprintf(szResult, "Error Connecting To Server");
	m_ThreadMarshal.GetResult(bResult_OK, szResult);

	if(m_Settings.m_bSound)
	{
		::Sleep(2500);
		PlaySound((LPCTSTR) IDR_WAVE_DISAPPOINTED, NULL, SND_RESOURCE | SND_SYNC);
	}

	if(m_Settings.m_bAutoRetry)
	{
		pMainFrame->NotifyIcon(NIM_MODIFY, IDI_ICON_TRAY_ERROR);
		CAutoRetryDlg D;
		strcpy(D.m_szMessage, szResult);
		if(D.DoModal() == IDCANCEL)
		{
			m_bPostStopNoSound = TRUE;
			OnPostStop();
		}
		else
		{
			pMainFrame->NotifyIcon(NIM_MODIFY, IDI_ICON_TRAY_POSTING);
			List_BitmapFromTo(IMAGE_POSTING, IMAGE_QUEUE, CTaskObject::PM_QUEUED);
			m_ThreadMarshal.Reconnect();
		}
	}
	else
	{
		m_bPostStopNoSound = TRUE; 
		OnPostStop();
		AfxMessageBox("Error Connecting To Server", MB_ICONSTOP);
	}

	return(0);
}

LRESULT CPostMostView::OnThread_ServerNotReady(WPARAM wParam, LPARAM lParam)
{
	CMainFrame* pMainFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	pMainFrame->SetProgressIndicator("");

	if(m_Settings.m_bSound)
	{
		::Sleep(2500);
		PlaySound((LPCTSTR) IDR_WAVE_DISAPPOINTED, NULL, SND_RESOURCE | SND_SYNC);
	}

	TCHAR szMessage[512];
	sprintf(szMessage, "Server Not Ready!\r\n\r\n%s", m_ThreadMarshal.GetServerConnectString());
	// AfxMessageBox(szMessage, MB_ICONSTOP);

	if(m_Settings.m_bAutoRetry)
	{
		CAutoRetryDlg RetryDlg;
		strcpy(RetryDlg.m_szMessage, szMessage);

		if(RetryDlg.DoModal() == IDCANCEL)
		{
			m_bPostStopNoSound = TRUE; 
			OnPostStop();
		}
		else m_ThreadMarshal.Reconnect();
	}
	else
	{
		m_bPostStopNoSound = TRUE; 
		OnPostStop();
		AfxMessageBox(szMessage, MB_ICONSTOP);
	}

	return(0);
}

LRESULT CPostMostView::OnThread_Ready(WPARAM wParam, LPARAM lParam)
{
	TRACE("CPostMostView::OnThread_Ready()\n");
	CMainFrame* pMainFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	pMainFrame->SetProgressIndicator("");

	if(!m_bRunning) return(0);

	// Assign Next Task
	CListCtrl& theList = GetListCtrl();
	int nItems = theList.GetItemCount();
	int kk;
	LVITEM theItem;
	::ZeroMemory(&theItem, sizeof(LVITEM));
	theItem.mask = LVIF_IMAGE;

	BOOL bFirstTask = TRUE;
	BOOL bResult_OK;
	char szResult[1024];

	CTaskObject* pTaskObject;

	// If we just posted one, set the new image
	for(kk = 0; kk < nItems; kk++)
	{
		theItem.iItem = kk;
		theList.GetItem(&theItem);

		if(theItem.iImage == IMAGE_POSTING)	// 1
		{
			bFirstTask = FALSE;

			pTaskObject = (CTaskObject*) theList.GetItemData(kk);

			if(m_ThreadMarshal.GetResult(bResult_OK, szResult))
				theList.SetItemText(kk, 2, szResult);

			UpdatePartsDisplay(kk, pTaskObject);

			if(bResult_OK == TRUE)
			{
				theItem.iImage = IMAGE_DONE;	// 2
				pTaskObject->m_nState = CTaskObject::PM_POSTED;
			}
			else
			{
				if((m_Settings.m_bAutoRetry == TRUE) && (lParam == 0))
				{
					CAutoRetryDlg RetryDlg;

					strcpy(RetryDlg.m_szMessage, szResult);
					
					if(RetryDlg.DoModal() == IDCANCEL)
					{
						theItem.iImage = IMAGE_QUEUE;
						theList.SetItem(&theItem);
						pTaskObject->m_nState = CTaskObject::PM_QUEUED;
						m_bPostStopNoSound = TRUE;
						OnPostStop();
						m_bPostStopNoSound = FALSE;
						return(0);
					}
					else
					{
						// Resubmit job...
						pTaskObject->m_nState = CTaskObject::PM_QUEUED;
						m_ThreadMarshal.Assign_Task(pTaskObject);
						if(m_Settings.m_bHighlightCurrentFile)
							theList.EnsureVisible(kk, FALSE);

						return(0);
					}
				}
				else
				{
					if(lParam == 0) // thread wasn't m_STOP'd
					{
						pTaskObject->m_nState = CTaskObject::PM_ERROR;
						theItem.iImage = IMAGE_ERROR;
						theList.SetItem(&theItem);
						OnPostStop();
						AfxMessageBox(szResult, MB_ICONSTOP);
						return(0);
					}
					else
					{
						pTaskObject->m_nState = CTaskObject::PM_QUEUED;
						theItem.iImage = IMAGE_QUEUE;
					}
				}

			}
			theList.SetItem(&theItem);
			break;
		}
	}

	// If task was m_STOP'd, then we're done with it..
	if(lParam != 0)
		return(0);

	// Get New Item To Assign
	for(kk = 0; kk < nItems; kk++)
	{
		theItem.iItem = kk;
		theList.GetItem(&theItem);

		if(theItem.iImage == IMAGE_QUEUE) // 0
		{
			pTaskObject = (CTaskObject*) theList.GetItemData(kk);
			
			theItem.iImage = IMAGE_POSTING;	// 1
			theList.SetItem(&theItem);

			m_ThreadMarshal.Assign_Task(pTaskObject);

			if(m_Settings.m_bHighlightCurrentFile)
				theList.EnsureVisible(kk, FALSE);
			
			if(!bFirstTask)
			{
				if(bResult_OK)
				{
					if(m_Settings.m_bSound) PlaySound((LPCTSTR) IDR_WAVE_WOOF, NULL, SND_ASYNC | SND_RESOURCE | SND_NOSTOP);
				}
				else
				{
					if(m_Settings.m_bSound) PlaySound((LPCTSTR) IDR_WAVE_ERROR, NULL, SND_ASYNC | SND_RESOURCE | SND_NOSTOP);
				}
			}
			return(0);
		}
	}

	// Nothing Left To Assign
	m_ThreadMarshal.Assign_Task(NULL);
	m_bPostStopNoSound = TRUE; 
	OnPostStop();
	m_bPostStopNoSound = FALSE;
	::Sleep(960);
	if(m_Settings.m_bSound) PlaySound((LPCTSTR) IDR_WAVE_XFER_COMPLETE, NULL, SND_ASYNC | SND_RESOURCE);
	return(0);
}

/*
int CPostMostView::GetBatchProgress()
{
	// Assign Next Task
	CListCtrl& theList = GetListCtrl();
	int nItems = theList.GetItemCount();

	int kk;
	LVITEM theItem;
	::ZeroMemory(&theItem, sizeof(LVITEM));
	theItem.mask = LVIF_IMAGE;

	// Count the number in Queue, Completed [if posting, it's in queue]
	int nDone = 0;

	for(kk = 0; kk < nItems; kk++)
	{
		theItem.iItem = kk;
		if(theList.GetItem(&theItem))
		{
			if(theItem.iImage == IMAGE_DONE) ++nDone;
			if(theItem.iImage == IMAGE_ERROR) ++nDone;
		}
	}

	// Return rough position based on results..
	if((nItems == 0) || (nDone == 0)) return(0);

	double d_total = (double) nItems;
	double d_done  = (double) nDone;
	double d = (d_done / d_total) * (double) 100.0;
	return((int) d);
}
*/
void CPostMostView::OnUpdateFileClearDoneFiles(CCmdUI* pCmdUI) 
{
	if(m_bRunning)
		pCmdUI->Enable(FALSE);
	else
	{
		pCmdUI->Enable(__FilesInQueue_OK());
	}
}

void CPostMostView::OnFileClearDoneFiles() 
{
	CDeleteTaskDlg Dlg;

	strcpy(Dlg.m_szMessage, "Remove All Posted Files From The List?");
	
	if(Dlg.DoModal() == IDOK)
	{
		CWaitCursor wc;

		CListCtrl& theList = GetListCtrl();
		int nItems = theList.GetItemCount();

		int kk;
		LVITEM theItem;
		::ZeroMemory(&theItem, sizeof(LVITEM));
		theItem.mask = LVIF_IMAGE;

		CPtrArray TasksToClear;
		CTaskObject* pTaskObject;

		for(kk = (nItems-1); kk >= 0; kk--)
		{
			theItem.iItem = kk;
			if(theList.GetItem(&theItem))
			{
				if(theItem.iImage == IMAGE_DONE)
				{
					pTaskObject = (CTaskObject*) theList.GetItemData(kk);
					TasksToClear.Add(pTaskObject);
					theList.DeleteItem(kk);
				}
			}
		}

		if(Dlg.m_bCheckValue == TRUE)
			SaveTasksToHistory(TasksToClear);

		for(kk = 0; kk < TasksToClear.GetSize(); kk++)
		{
			pTaskObject = (CTaskObject*) TasksToClear.GetAt(kk);
			delete pTaskObject;
		}

		TasksToClear.RemoveAll();
	}
}

void CPostMostView::OnUpdateFileClearList(CCmdUI* pCmdUI) 
{
	if(m_bRunning)
		pCmdUI->Enable(FALSE);
	else
	{
		if(GetListCtrl().GetItemCount() > 0)
			pCmdUI->Enable(TRUE);
		else
			pCmdUI->Enable(FALSE);
	}
}

void CPostMostView::OnFileClearList() 
{
	CDeleteTaskDlg Dlg;

	strcpy(Dlg.m_szMessage, "Remove All Files From The List?");
	
	if(Dlg.DoModal() == IDOK)
	{
		RemoveAllTasks(Dlg.m_bCheckValue);
	}
}

void CPostMostView::OnUpdateFileClearErrors(CCmdUI* pCmdUI) 
{
	if(m_bRunning)
		pCmdUI->Enable(FALSE);
	else
	{
		pCmdUI->Enable(__FilesInQueue_ERR());
	}
}

void CPostMostView::OnFileClearErrors() 
{
	if(AfxMessageBox("Resubmit Files In Error Into Queue?", MB_YESNO | MB_ICONQUESTION) == IDNO)
		return;

	// Change all IMAGE_ERROR into IMAGE_QUEUE
	List_BitmapFromTo(IMAGE_ERROR, IMAGE_QUEUE, CTaskObject::PM_QUEUED);
}

void CPostMostView::List_SetItemImageAndState(int nIndex, int nImageTo, int nStateTo)
{
	CListCtrl& theList = GetListCtrl();
	int nItems = theList.GetItemCount();
	if(nIndex >= nItems) return;

	LVITEM theItem;
	::ZeroMemory(&theItem, sizeof(LVITEM));
	theItem.mask = LVIF_IMAGE;
	theItem.iItem = nIndex;
	theList.GetItem(&theItem);
	theItem.iImage = nImageTo;
	theList.SetItem(&theItem);
	CTaskObject* pTaskObject = (CTaskObject*) theList.GetItemData(nIndex);
	pTaskObject->m_nState = nStateTo;
}

// if nImageFrom == -1, then all images are matched
// if nStateTo == -1, then state is NOT modified
void CPostMostView::List_BitmapFromTo(int nImageFrom, int nImageTo, int nStateTo)
{
	CListCtrl& theList = GetListCtrl();
	int nItems = theList.GetItemCount();
	int kk;
	LVITEM theItem;
	::ZeroMemory(&theItem, sizeof(LVITEM));
	theItem.mask = LVIF_IMAGE;
	CTaskObject* pTaskObject;

	for(kk = 0; kk < nItems; kk++)
	{
		theItem.iItem = kk;
		theList.GetItem(&theItem);

		if((theItem.iImage == nImageFrom) || (nImageFrom == -1))
		{
			theItem.iImage = nImageTo;
			theList.SetItem(&theItem);
			if(nStateTo >= 0)
			{
				pTaskObject = (CTaskObject*) theList.GetItemData(kk);
				pTaskObject->m_nState = nStateTo;
			}
			theList.SetItemText(kk, 2, "");
		}
	}
}

void CPostMostView::OnUpdateFileQueueAll(CCmdUI* pCmdUI) 
{
	if(m_bRunning)
		pCmdUI->Enable(FALSE);
	else
	{
		if(GetListCtrl().GetItemCount() == 0)
			pCmdUI->Enable(FALSE);
		else
		{
			if(__FilesInQueue_ERR() || __FilesInQueue_OK())
				pCmdUI->Enable(TRUE);
			else
				pCmdUI->Enable(FALSE);
		}
	}
}

void CPostMostView::OnFileQueueAll() 
{
	if(AfxMessageBox("Resubmit All Files Into Queue?", MB_YESNO | MB_ICONQUESTION) == IDNO)
		return;

	CListCtrl& theList = GetListCtrl();
	int nItems = theList.GetItemCount();
	int kk;
	LVITEM theItem;
	::ZeroMemory(&theItem, sizeof(LVITEM));
	theItem.mask = LVIF_IMAGE;
	CTaskObject* pTaskObject;

	// Change all into IMAGE_QUEUE
	for(kk = 0; kk < nItems; kk++)
	{
		theItem.iItem = kk;
		theList.GetItem(&theItem);

		if(theItem.iImage != IMAGE_QUEUE)
		{
			theItem.iImage = IMAGE_QUEUE;
			theList.SetItem(&theItem);
			pTaskObject = (CTaskObject*) theList.GetItemData(kk);
			pTaskObject->m_nState = CTaskObject::PM_QUEUED;
			theList.SetItemText(kk, 2, "");
		}
	}
}


void CPostMostView::OnUpdateFileAddFiles(CCmdUI* pCmdUI) 
{
	if(m_bRunning)
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);
}

void CPostMostView::OnFileAddFiles() 
{
	CFileDialog F_Dlg(TRUE);

	F_Dlg.m_ofn.Flags |= OFN_ALLOWMULTISELECT;

	// Increase Buffer For Multi-Select Storage
	TCHAR* pBuffer = new TCHAR[24576];	// 24K
	
	*pBuffer = '\0';

	F_Dlg.m_ofn.lpstrFile = pBuffer;
	F_Dlg.m_ofn.nMaxFile = 24576;

	TCHAR szCurrentDirectory[_MAX_PATH];
	::GetCurrentDirectory(_MAX_PATH, szCurrentDirectory);

	TCHAR szInitialDirectory[_MAX_PATH];
	strcpy(szInitialDirectory, m_Settings.m_szLastAddDir);

	if(strlen(szInitialDirectory) == 0)
		strcpy(szInitialDirectory, szCurrentDirectory);

	F_Dlg.m_ofn.lpstrInitialDir = &szInitialDirectory[0];

	if(!::CM_IsDirectory(F_Dlg.m_ofn.lpstrInitialDir))
		strcpy(szInitialDirectory, szCurrentDirectory);

	if(m_Settings.m_bSound)
		if(m_Settings.m_bSound) PlaySound((LPCTSTR) IDR_WAVE_TAP, NULL, SND_ASYNC | SND_RESOURCE | SND_NOSTOP);

	if(F_Dlg.DoModal() == IDOK)
	{
		// Get Filenames
		POSITION pos;
		m_Dropped_Files.RemoveAll();
		pos = F_Dlg.GetStartPosition();

		while(pos != (POSITION) NULL)
		{
			if(m_Settings.m_bSortFilesOnAdd)
				::CM_CSA_INSERT(m_Dropped_Files, (LPCTSTR) F_Dlg.GetNextPathName(pos));
			else
				m_Dropped_Files.Add( (LPCTSTR) F_Dlg.GetNextPathName(pos) );
		}
		
		if(m_Dropped_Files.GetSize() > 0)
		{
			PostMessage(WM_FILES_DROPPED);
		}
		else
		{
			if(m_Settings.m_bSound) PlaySound((LPCTSTR) IDR_WAVE_VAULT, NULL, SND_ASYNC | SND_RESOURCE | SND_NOSTOP);
		}
	}
	else
	{
		if(m_Settings.m_bSound) PlaySound((LPCTSTR) IDR_WAVE_VAULT, NULL, SND_ASYNC | SND_RESOURCE | SND_NOSTOP);
	}

	// Release Buffer
	delete [] pBuffer;

	// Save Current Directory for next time..
	::GetCurrentDirectory(_MAX_PATH, m_Settings.m_szLastAddDir);
	
	// Reset Current Directory
	::SetCurrentDirectory(szCurrentDirectory);

}

void CPostMostView::OnUpdateIndicatorFiles(CCmdUI* pCmdUI)
{
	char szTT[64];
	int nFileCount = 0;
	int nCount = GetListCtrl().GetItemCount();

	CTaskObject* pTaskObject;
	DWORD dwTotalSizeBytes = 0;

	if(GetListCtrl().GetSelectedCount() > 0)
	{
		for(int kk = 0; kk < nCount; kk++)
		{
			if(GetListCtrl().GetItemState(kk, LVIS_SELECTED) == LVIS_SELECTED)
			{
				pTaskObject = (CTaskObject*) GetListCtrl().GetItemData(kk);
				dwTotalSizeBytes += pTaskObject->m_dwFileSize;
				++nFileCount;
			}
		}
	}
	else
	{
		for(int kk = 0; kk < nCount; kk++)
		{
			pTaskObject = (CTaskObject*) GetListCtrl().GetItemData(kk);
			dwTotalSizeBytes += pTaskObject->m_dwFileSize;
			++nFileCount;
		}
	}

	DWORD dwTotalSizeK = dwTotalSizeBytes >> 10;

	if(dwTotalSizeK < 1024)
	{
		if(nFileCount == nCount)
			sprintf(szTT, "%d Files (%d K)", nCount, dwTotalSizeK);
		else
			sprintf(szTT, "= %d Files (%d K)", nFileCount, dwTotalSizeK);
	}
	else
	{
		double dblFileSizeMB = (double) dwTotalSizeK;
		dblFileSizeMB = dblFileSizeMB / 1024.0;
		if(nFileCount == nCount)
			sprintf(szTT, "%d Files (%0.1lf MB)", nCount, dblFileSizeMB);
		else
			sprintf(szTT, "= %d Files (%0.1lf MB)", nFileCount, dblFileSizeMB);
	}
	
	pCmdUI->Enable(TRUE);
	pCmdUI->SetText(szTT);
}

void CPostMostView::OnUpdateFileClearSelected(CCmdUI* pCmdUI) 
{
	if(m_bRunning)
	{
		pCmdUI->Enable(FALSE);
		return;
	}

	if(GetListCtrl().GetSelectedCount() > 0)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
	
}

void CPostMostView::OnFileClearSelected() 
{
	// Remove Selected Items From List
	CDeleteTaskDlg Dlg;

	sprintf(Dlg.m_szMessage, "Remove %d Selected Files From List?", GetListCtrl().GetSelectedCount());

	if(Dlg.DoModal() == IDOK)
	{
		CWaitCursor wc;

		int kk, nCount;
		CListCtrl& theList = GetListCtrl();
		CPtrArray TasksToClear;
		CTaskObject* pTaskObject;
		nCount = GetListCtrl().GetItemCount();

		for(kk = nCount - 1; kk >= 0; kk--)
		{
			if(theList.GetItemState(kk, LVIS_SELECTED) == LVIS_SELECTED)
			{
				pTaskObject = (CTaskObject*) theList.GetItemData(kk);
				TasksToClear.Add(pTaskObject);
				theList.DeleteItem(kk);
			}
		}

		if(Dlg.m_bCheckValue == TRUE)
			SaveTasksToHistory(TasksToClear);

		for(kk = 0; kk < TasksToClear.GetSize(); kk++)
		{
			pTaskObject = (CTaskObject*) TasksToClear.GetAt(kk);
			delete pTaskObject;
		}

		TasksToClear.RemoveAll();

	}


}

void CPostMostView::RemoveAllTasks(BOOL bWriteToHistory)
{
	CListCtrl& theList = GetListCtrl();

	theList.LockWindowUpdate();

	int nItems = theList.GetItemCount();

	int kk;

	CPtrArray TasksToClear;
	CTaskObject* pTaskObject;

	for(kk = (nItems-1); kk >= 0; kk--)
	{
		pTaskObject = (CTaskObject*) theList.GetItemData(kk);
		TasksToClear.Add(pTaskObject);
		theList.DeleteItem(kk);
	}
	
	if(bWriteToHistory)
		SaveTasksToHistory(TasksToClear);

	for(kk = 0; kk < TasksToClear.GetSize(); kk++)
	{
		pTaskObject = (CTaskObject*) TasksToClear.GetAt(kk);
		delete pTaskObject;
	}

	TasksToClear.RemoveAll();

	GetListCtrl().UnlockWindowUpdate();

}

/*
void CPostMostView::RemoveTask(int nIndex)
{
	CTaskObject* pTaskObject = (CTaskObject*) GetListCtrl().GetItemData(nIndex);

	if(pTaskObject != NULL)
		delete pTaskObject;

	GetListCtrl().DeleteItem(nIndex);
}
*/


void CPostMostView::OnUpdateFileTaskProperties(CCmdUI* pCmdUI) 
{
	if(m_bRunning)
		pCmdUI->Enable(FALSE);
	else
	{
		if(GetListCtrl().GetSelectedCount() > 0)
			pCmdUI->Enable(TRUE);
		else
			pCmdUI->Enable(FALSE);
	}
	// TODO: Add your command update UI handler code here
	
}

void CPostMostView::OnFileTaskProperties() 
{
	CTaskObject* pTaskObject;

	int nSelected = GetListCtrl().GetSelectedCount();
	int nCurrentItem = 0;

	int nItem;
	TCHAR szPartCount[32];
	TCHAR szTitle[64];
	POSITION pos = GetListCtrl().GetFirstSelectedItemPosition();
	CRect rectItem;

	while(pos != NULL)
	{
		++nCurrentItem;
		nItem = GetListCtrl().GetNextSelectedItem(pos);
		pTaskObject = (CTaskObject*) GetListCtrl().GetItemData(nItem);
		
		GetListCtrl().EnsureVisible(nItem, FALSE);

		if(pTaskObject != NULL)
		{
			GetListCtrl().GetItemRect(nItem, &rectItem, LVIR_LABEL);
			GetListCtrl().ClientToScreen(&rectItem);

			sprintf(szTitle, "Task Item (%d of %d)", nCurrentItem, nSelected);

			if(ViewTaskProperties(pTaskObject, szTitle, &rectItem) == IDCANCEL)
				break;

			// Update list view with new szSubject and number of parts
			GetListCtrl().SetItemText(nItem, 0, pTaskObject->m_szSubject);
			sprintf(szPartCount, "%d/%d", pTaskObject->m_dwaPartsToPost.GetSize(), ::CM_CalcNumberOfParts(pTaskObject->m_dwFileSize, pTaskObject->m_nMaxLines));
			if(pTaskObject->m_bPostPrefixText == TRUE)
				strcat(szPartCount, "+0");
			GetListCtrl().SetItemText(nItem, 1, szPartCount);
			GetListCtrl().SetItemText(nItem, 3, (LPCTSTR) pTaskObject->m_strGroups);

		}
	}
}

int CPostMostView::ViewTaskProperties(CTaskObject* pTaskObject, LPCTSTR szTitle, LPRECT lprectItem)
{
	CTaskProp_FileAndParts PP_FileAndParts;
	CTaskProp_Groups       PP_Groups;
	CTaskProp_PrefixText   PP_PrefixText;
	CTaskProp_Log          PP_Log;

	CPostMostPropertySheet PS(szTitle);

	PS.m_psh.dwFlags |= PSH_NOAPPLYNOW;

	if(lprectItem != NULL)
		PS.m_rectAnimateFrom = *lprectItem;

	PS.AddPage(&PP_FileAndParts);
	PS.AddPage(&PP_Groups);
	PS.AddPage(&PP_PrefixText);
	PS.AddPage(&PP_Log);

	CTaskObject proxyTaskObject;

	proxyTaskObject.Copy(pTaskObject);

	PP_FileAndParts.m_pTaskObject = &proxyTaskObject;
	PP_FileAndParts.m_bSound = m_Settings.m_bSound;
	PP_Groups.m_pTaskObject = &proxyTaskObject;
	PP_Groups.m_pSettings = &m_Settings;
	PP_Groups.m_bSound = m_Settings.m_bSound;
	PP_PrefixText.m_pTaskObject = &proxyTaskObject;
	PP_PrefixText.m_bSound = m_Settings.m_bSound;
	PP_Log.m_pTaskObject = &proxyTaskObject;
	PP_Log.m_bSound = m_Settings.m_bSound;


	if(PS.DoModal() == IDCANCEL)
		return(IDCANCEL);

	// Okay, save object information
	pTaskObject->Copy(&proxyTaskObject);

	return(IDOK);
}

void CPostMostView::OnUpdateFileHistory(CCmdUI* pCmdUI) 
{
	if(m_bRunning)
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);
}

void CPostMostView::OnFileHistory() 
{
	CHistoryDlg Dlg;

	CMainFrame* pMainFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	pMainFrame->GetHistoryButtonRect(&Dlg.m_rectAnimateFrom);

	Dlg.m_pView = this;
	Dlg.m_bSound = m_Settings.m_bSound;
	Dlg.DoModal();
}

void CPostMostView::SaveTasksToHistory(CPtrArray& theTasks)
{
	if(theTasks.GetSize() == 0) return;

	CFile theHistoryFile;
	CFileException cfe;

	if(theHistoryFile.Open("HISTORY.DAT", CFile::modeWrite | CFile::modeCreate | CFile::modeNoTruncate, &cfe) == FALSE)
	{
		TCHAR szError[600];
		TCHAR szErrorText[512];
		cfe.GetErrorMessage(szErrorText, 512);
		sprintf(szError, "Error Saving To History!\r\n\r\n%s", szErrorText);
		AfxMessageBox(szError, MB_ICONEXCLAMATION);
		return;
	}

	theHistoryFile.SeekToEnd();

	int nCount = theTasks.GetSize();
	CTaskObject* pTaskObject;

	for(int k = 0; k < nCount; k++)
	{
		pTaskObject = (CTaskObject*) theTasks.GetAt(k);
		if(pTaskObject != NULL)
		{
			if(strlen(pTaskObject->m_szHistoryDateTime) == 0)
				pTaskObject->WriteToFile(theHistoryFile, TRUE);
		}
	}

	theHistoryFile.Close();
}

void CPostMostView::SaveTasksToQueue()
{
	int nCount = GetListCtrl().GetItemCount();

	if(nCount == 0) 
	{
		::DeleteFile("QUEUE.DAT"); // Ensure it's deleted..
		return;
	}

	CFile theQueueFile;
	CFileException cfe;

	if(theQueueFile.Open("QUEUE.DAT", CFile::modeWrite | CFile::modeCreate, &cfe) == FALSE)
	{
		TCHAR szError[600];
		TCHAR szErrorText[512];
		cfe.GetErrorMessage(szErrorText, 512);
		sprintf(szError, "Error Saving To Queue File!\r\n\r\n%s", szErrorText);
		AfxMessageBox(szError, MB_ICONEXCLAMATION);
		return;
	}

	CTaskObject* pTaskObject;

	for(int k = 0; k < nCount; k++)
	{
		pTaskObject = (CTaskObject*) GetListCtrl().GetItemData(k);
		if(pTaskObject != NULL)
		{
			pTaskObject->WriteToFile(theQueueFile, FALSE);
		}
	}

	theQueueFile.Close();
}

void CPostMostView::LoadTasksFromQueue()
{
	CFile theQueueFile;
	CFileException cfe;

	if(theQueueFile.Open("QUEUE.DAT", CFile::modeRead, &cfe) == FALSE)
		return;

	CTaskObject OneTask;

	while(OneTask.ReadFromFile(theQueueFile))
	{
		AppendTaskToQueue(OneTask);
	}

	theQueueFile.Close();
}

void CPostMostView::OnUpdateFileQueueSel(CCmdUI* pCmdUI) 
{
	if(GetListCtrl().GetSelectedCount() == 0)
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(__FilesSelected_Not_Q());
}

void CPostMostView::OnFileQueueSel() 
{
	int nCount = GetListCtrl().GetSelectedCount();

	if(nCount == 0) return;

	TCHAR szText[64];

	sprintf(szText, "Re-Queue Selected %d Files?", nCount);

	if(AfxMessageBox(szText, MB_OKCANCEL) == IDCANCEL)
		return;

	// Re-Queue Selected Files
	CTaskObject* pTaskObject;
	LVITEM theItem;
	int k, nItems;
	nItems = GetListCtrl().GetItemCount();

	for(k = 0; k < nItems; k++)
	{
		if(GetListCtrl().GetItemState(k, LVIS_SELECTED) == LVIS_SELECTED)
		{
			pTaskObject = (CTaskObject*) GetListCtrl().GetItemData(k);
			pTaskObject->m_nState = CTaskObject::PM_QUEUED;

			::ZeroMemory(&theItem, sizeof(LVITEM));
			theItem.mask = LVIF_IMAGE;
			theItem.iItem = k;
			GetListCtrl().GetItem(&theItem);
			theItem.iImage = IMAGE_QUEUE;
			GetListCtrl().SetItem(&theItem);
			GetListCtrl().SetItemText(k, 2, "");
		}
	}
}

void CPostMostView::AppendTaskToQueue(CTaskObject& theTask)
{
	int nAppendPos = GetListCtrl().GetItemCount();

	CTaskObject* pNewTask;

	int nImage;
	int nParts;
	TCHAR szPartCount[32];

	pNewTask = new CTaskObject;
	pNewTask->Copy(&theTask);

	nParts = CM_CalcNumberOfParts(pNewTask->m_dwFileSize, pNewTask->m_nMaxLines);

	sprintf(szPartCount, "%d", nParts);
	sprintf(szPartCount, "%d/%d", theTask.m_dwaPartsToPost.GetSize(), nParts);
	if(theTask.m_bPostPrefixText == TRUE) strcat(szPartCount, "+0");

	switch(pNewTask->m_nState)
	{
	case CTaskObject::PM_ERROR:
		nImage = IMAGE_ERROR;
		break;
	case CTaskObject::PM_POSTED:
		nImage = IMAGE_DONE;
		break;
	case CTaskObject::PM_HOLDING:
		nImage = IMAGE_HOLDING;
		break;
	case CTaskObject::PM_QUEUED:
	case CTaskObject::PM_UNDEFINED:
	default:
		nImage = IMAGE_QUEUE;
		break;
	}

	GetListCtrl().InsertItem(nAppendPos, pNewTask->m_szSubject, nImage);
	GetListCtrl().SetItemText(nAppendPos, 1, szPartCount);
	GetListCtrl().SetItemText(nAppendPos, 2, pNewTask->m_szLastResult);
	GetListCtrl().SetItemText(nAppendPos, 3, (LPCTSTR) pNewTask->m_strGroups);
	GetListCtrl().SetItemData(nAppendPos, (DWORD) pNewTask);
}

BOOL CPostMostView::__FilesInQueue_ERR()
{
	// Check to see if any items are marked in ERR
	CListCtrl& theList = GetListCtrl();
	int nItems = theList.GetItemCount();
	int kk;
	LVITEM theItem;
	::ZeroMemory(&theItem, sizeof(LVITEM));
	theItem.mask = LVIF_IMAGE;

	for(kk = 0; kk < nItems; kk++)
	{
		theItem.iItem = kk;
		theList.GetItem(&theItem);

		if(theItem.iImage == IMAGE_ERROR)
			return TRUE;
	}

	return(FALSE);
}

BOOL CPostMostView::__FilesInQueue_OK()
{
	// Check to see if any items are marked as OK
	CListCtrl& theList = GetListCtrl();
	int nItems = theList.GetItemCount();
	int kk;
	LVITEM theItem;
	::ZeroMemory(&theItem, sizeof(LVITEM));
	theItem.mask = LVIF_IMAGE;

	for(kk = 0; kk < nItems; kk++)
	{
		theItem.iItem = kk;
		theList.GetItem(&theItem);

		if(theItem.iImage == IMAGE_DONE)
			return TRUE;
	}

	return(FALSE);
}

BOOL CPostMostView::__FilesSelected_Not_Q()
{
	// Check to see if any items are marked for QUEUE
	CListCtrl& theList = GetListCtrl();
	int nItems = theList.GetItemCount();
	int kk;
	LVITEM theItem;
	::ZeroMemory(&theItem, sizeof(LVITEM));
	theItem.mask = LVIF_IMAGE;

	for(kk = 0; kk < nItems; kk++)
	{
		if(theList.GetItemState(kk, LVIS_SELECTED) == LVIS_SELECTED)
		{
			theItem.iItem = kk;
			theList.GetItem(&theItem);

			if(theItem.iImage != IMAGE_QUEUE)
				return TRUE;
		}
	}

	return(FALSE);
}

BOOL CPostMostView::__FilesInQueue_Q()
{
	// Check to see if any items are marked for QUEUE
	CListCtrl& theList = GetListCtrl();
	int nItems = theList.GetItemCount();
	int kk;
	LVITEM theItem;
	::ZeroMemory(&theItem, sizeof(LVITEM));
	theItem.mask = LVIF_IMAGE;

	for(kk = 0; kk < nItems; kk++)
	{
		theItem.iItem = kk;
		theList.GetItem(&theItem);

		if(theItem.iImage == IMAGE_QUEUE)
			return TRUE;
	}

	return(FALSE);
}

// int __ComputeBatchSize()
UINT CPostMostView::__ComputeBatchSize()
{
	// Compute batch size in lines
	CListCtrl& theList = GetListCtrl();
	CTaskObject* pTaskObject;

	int kk;
	int nItems = theList.GetItemCount();

	UINT nSizeBatch = 0;

	LVITEM theItem;
	::ZeroMemory(&theItem, sizeof(LVITEM));
	theItem.mask = LVIF_IMAGE;
	
	int n, nParts, nPTPSize, nLines;

	for(kk = 0; kk < nItems; kk++)
	{
		theItem.iItem = kk;
		theList.GetItem(&theItem);

		if(theItem.iImage == IMAGE_QUEUE)
		{
			pTaskObject = (CTaskObject*) theList.GetItemData(kk);
			nParts = ::CM_CalcNumberOfParts(pTaskObject->m_dwFileSize, pTaskObject->m_nMaxLines);
			nPTPSize = pTaskObject->m_dwaPartsToPost.GetSize();
			if(nPTPSize > 0)
			{
				for(n = 0; n < nPTPSize; n++)
				{
					if(pTaskObject->m_dwaPartsToPost.GetAt(n) != (UINT) nParts)
					{
						// Full part to post..
						nSizeBatch += pTaskObject->m_nMaxLines;
					}
					else
					{
						nLines = ((pTaskObject->m_dwFileSize % (pTaskObject->m_nMaxLines * YENCLEN)) / YENCLEN);
						nSizeBatch += nLines;
					}
				}
			}
		}
	}

	TRACE("__ComputeBatchSize() = %d lines\n", nSizeBatch);
	return(nSizeBatch);
}

void CPostMostView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// Adjust point for keyboard activation
	if((point.x == -1) && (point.y == -1))
	{
		CRect rcClient;
		GetClientRect(&rcClient);
		point = rcClient.TopLeft();
		point.Offset(8,8);
		ClientToScreen(&point);
	}

	// Load Context Menu
	CMenu menuContext;
	menuContext.LoadMenu(IDR_MENU_CONTEXT);

	// Get Context Menu from First Sub-Menu
	CMenu* pMenu = menuContext.GetSubMenu(0);
	ASSERT_VALID(pMenu);

	// Display it..
	pMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, point.x, point.y, AfxGetMainWnd(), NULL);
	
}

void CPostMostView::OnUpdateFileReassignNewsgroups(CCmdUI* pCmdUI) 
{
	if( (GetListCtrl().GetSelectedCount() > 0) && (m_bRunning == FALSE))
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

void CPostMostView::OnFileReassignNewsgroups() 
{
	DWORD dwPageActivation = 0;

	CPropertySheet			PS;
	CPropPage_Add_Groups	PP_Groups;

	PP_Groups.m_pdwActivation = &dwPageActivation;
	PP_Groups.m_bSound = m_Settings.m_bSound;
	PP_Groups.m_pSettings = &m_Settings;

	PS.SetTitle("Re-Assign Newsgroups");
	PS.AddPage(&PP_Groups);
	PS.m_psh.dwFlags |= PSH_NOAPPLYNOW;

	if(PS.DoModal() == IDCANCEL)
	{
		if(m_Settings.m_bSound) PlaySound((LPCTSTR) IDR_WAVE_VAULT, NULL, SND_ASYNC | SND_RESOURCE | SND_NOSTOP);
		return;
	}
	
	if(m_Settings.m_bSound)
		PlaySound((LPCTSTR) IDR_WAVE_SHUT, NULL, SND_ASYNC | SND_RESOURCE | SND_NOSTOP);

	LPCTSTR lpszGroupList = (LPCTSTR) PP_Groups.m_strGroupList;

	CTaskObject* pTaskObject;
	int nItems = GetListCtrl().GetItemCount();
	int kk;

	for(kk = 0; kk < nItems; kk++)
	{
		if(GetListCtrl().GetItemState(kk, LVIS_SELECTED) == LVIS_SELECTED)
		{
			pTaskObject = (CTaskObject*) GetListCtrl().GetItemData(kk);
			if(pTaskObject != NULL)
			{
				pTaskObject->m_strGroups = lpszGroupList;
				GetListCtrl().SetItemText(kk, 3, lpszGroupList);
			}
		}
	}
}

void CPostMostView::UpdateItemDisplay(int nIndex)
{
	CTaskObject* pTaskObject;
	pTaskObject = (CTaskObject*) GetListCtrl().GetItemData(nIndex);

	int nParts;
	TCHAR szPartCount[32];

	nParts = CM_CalcNumberOfParts(pTaskObject->m_dwFileSize, pTaskObject->m_nMaxLines);

	sprintf(szPartCount, "%d/%d", pTaskObject->m_dwaPartsToPost.GetSize(), nParts);
	if(pTaskObject->m_bPostPrefixText == TRUE) strcat(szPartCount, "+0");

	// Set Item Image
	LVITEM theItem;
	::ZeroMemory(&theItem, sizeof(LVITEM));
	theItem.mask = LVIF_IMAGE;
	theItem.iItem = nIndex;
	switch(pTaskObject->m_nState)
	{
	case CTaskObject::PM_UNDEFINED:
		theItem.iImage = IMAGE_ERROR;
		pTaskObject->m_nState = CTaskObject::PM_ERROR;
		break;
	case CTaskObject::PM_QUEUED:
		theItem.iImage = IMAGE_QUEUE;
		break;
	case CTaskObject::PM_ERROR:
		theItem.iImage = IMAGE_ERROR;
		break;
	case CTaskObject::PM_POSTED:
		theItem.iImage = IMAGE_DONE;
		break;
	}
	GetListCtrl().SetItem(&theItem);

	// Set Item Column Text
	GetListCtrl().SetItemText(nIndex, 0, pTaskObject->m_szSubject);
	GetListCtrl().SetItemText(nIndex, 1, szPartCount);
	GetListCtrl().SetItemText(nIndex, 2, pTaskObject->m_szLastResult);
	GetListCtrl().SetItemText(nIndex, 3, (LPCTSTR) pTaskObject->m_strGroups);
}

void CPostMostView::UpdatePartsDisplay(int nIndex, CTaskObject* pTaskObject)
{
	int nParts = CM_CalcNumberOfParts(pTaskObject->m_dwFileSize, pTaskObject->m_nMaxLines);

	TCHAR szPartCount[32];

	sprintf(szPartCount, "%d/%d", pTaskObject->m_dwaPartsToPost.GetSize(), nParts);

	if(pTaskObject->m_bPostPrefixText == TRUE)
		strcat(szPartCount, "+0");

	CListCtrl& listCtrl = GetListCtrl();
	listCtrl.SetItemText(nIndex, 1, szPartCount);			// Computed Number Of Parts
}

void CPostMostView::OnUpdatePostStartAt(CCmdUI* pCmdUI) 
{
	if(m_bRunning)
		pCmdUI->Enable(FALSE);
	else
	{
		if(GetListCtrl().GetItemCount() == 0)
			pCmdUI->Enable(FALSE);
		else
		{
			pCmdUI->Enable(__FilesInQueue_Q());
		}
	}	
}

void CPostMostView::OnPostStartAt() 
{
	CDelayedPostingDlg D;

	D.m_nInit_Hour = m_Settings.m_nStartTimeSel[0];
	D.m_nInit_Min  = m_Settings.m_nStartTimeSel[1];
	D.m_nInit_AMPM = m_Settings.m_nStartTimeSel[2];

	if(D.DoModal() == IDOK)
	{
		m_Settings.m_nStartTimeSel[0] = D.m_nInit_Hour;
		m_Settings.m_nStartTimeSel[1] = D.m_nInit_Min;
		m_Settings.m_nStartTimeSel[2] = D.m_nInit_AMPM;
		
		m_TimeToStart = D.m_StartTime;

		// Set State Variables
		m_bWaiting = TRUE;
		m_bRunning = TRUE;

		// Update Tray Icon
		((CMainFrame*) AfxGetApp()->m_pMainWnd)->NotifyIcon(NIM_MODIFY, IDI_ICON_TRAY_WAITING);

		UpdateWaitTime();
	}
}

void CPostMostView::StartWaitTimer()
{
	m_nWaitTimerID = SetTimer(4926, 1000, NULL);	
	ASSERT(m_nWaitTimerID);

}

void CPostMostView::StopWaitTimer()
{
	KillTimer(m_nWaitTimerID);
}

void CPostMostView::UpdateWaitTime()
{
	CTime currentTime = CTime::GetCurrentTime();

	CTimeSpan timeToGo = m_TimeToStart - currentTime;

	TCHAR szTT[128];
	sprintf(szTT, "Waiting %02d:%02d:%02d", timeToGo.GetHours(), timeToGo.GetMinutes(), timeToGo.GetSeconds());

	CMainFrame* pMainFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	pMainFrame->SetProgressIndicator(szTT);

	if( (timeToGo.GetHours() <= 0) &&
		(timeToGo.GetMinutes() <= 0) &&
		(timeToGo.GetSeconds() <= 0) )
	{
		m_bWaiting = FALSE;
		m_bRunning = FALSE;

		((CMainFrame*) AfxGetApp()->m_pMainWnd)->NotifyIcon(NIM_MODIFY, IDI_ICON_TRAY_READY);

		OnPostStart();
	}

}


void CPostMostView::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == 4926)
	{
		TRACE("CPostMostView::OnTimer(%d)\n", nIDEvent);

		if(m_bRunning == FALSE) return;
		if(m_bWaiting == TRUE)
		{
			UpdateWaitTime();
			return;
		}

		// Posting .. See if we have the Stall Timeout Set
		if(m_Settings.m_bStallTimeoutEnabled == FALSE)
			return;

		// Get Progress and Check for Stall
		int n;
		int nSecondsToScan = m_Settings.m_nMinuteStallTimeout * 60;
		BOOL bFlatlined = TRUE;
		int nTransmissionHistory[300];

		if(m_ThreadMarshal.GetTransmissionHistory(nTransmissionHistory) == FALSE)
			return;

		CTime theTimeNow = CTime::GetCurrentTime();
		CTimeSpan theTimeSpan = theTimeNow - m_Time_Started;

		n = theTimeSpan.GetTotalSeconds();
		if(n < nSecondsToScan) return;

		for(n = 0; n < nSecondsToScan; n++)
		{
			if(nTransmissionHistory[n] != 0)
			{
				bFlatlined = FALSE;
				TRACE("Not Flatlined: nTransmissionHistory[%d] = %d\n", n, nTransmissionHistory[n]);
				break;
			}
		}

		if(bFlatlined)
		{
			// TODO: Stop and Restart
			TRACE("**** Stall Timer Exceeded - Start/Restart!\n");
			m_bPostStopNoSound = TRUE;
			OnPostStop();
			m_bPostStopNoSound = FALSE;
			OnPostStart();

		}
		return;

	}

	CListView::OnTimer(nIDEvent);
}

void CPostMostView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// if((m_bRunning == FALSE) && (nFlags & 0x20000000))  // ALT Key pressed
	if(m_bRunning == FALSE)
	{
		TRACE("nFlags = 0x%08X\n", nFlags);

		switch(nChar)
		{
			// CTRL-A selects all items
		case 1:
			List_SelectAllItems();
			break;
			// CTRL-U moves selected items up list
		case 21:
			List_MoveSelected_Up();
			break;

			// CTRL-D moves selected items up list
		case 4:
			List_MoveSelected_Down();
			break;

			// CTRL-T moves selected items to top
		case 20:
			List_MoveSelected_Top();
			break;

			// CTRL-B moves selected items to bottom
		case 2:
			List_MoveSelected_Bottom();
			break;

		default:
			break;
		}
	}

	TRACE("CPostMostView::OnChar:: nChar = %d, nFlags = %08X\n", nChar, nFlags);	
	CListView::OnChar(nChar, nRepCnt, nFlags);
}

void CPostMostView::List_SelectAllItems()
{
	int nItems = GetListCtrl().GetItemCount();
	for(int k = 0; k < nItems; k++)
		GetListCtrl().SetItemState(k, LVIS_SELECTED, LVIS_SELECTED);
}

void CPostMostView::List_MoveSelected_Up()
{
	CListCtrl& listCtrl = GetListCtrl();

	int nItems = listCtrl.GetItemCount();
	int nSelected = listCtrl.GetSelectedCount();

	if((nSelected == 0) || (nItems == 1))
		return;
	
	int k;
	BOOL bAnyShifted = FALSE;
	DWORD dwItem, dwItemPrev;
	CDWordArray dwa_AllItems;
	CDWordArray dwa_SelectedItems;
	dwa_SelectedItems.SetSize(0, nSelected);
	dwa_SelectedItems.SetSize(0, nItems);

	// Collect Item Information
	for(k = 0; k < nItems; k++)
	{
		dwa_AllItems.Add((DWORD) listCtrl.GetItemData(k));
		if(listCtrl.GetItemState(k, LVIS_SELECTED) == LVIS_SELECTED)
			::CM_DWA_INSERT(dwa_SelectedItems, (int) listCtrl.GetItemData(k));
	}

	// Shift Items in dwa varaibles
	for(k = 1; k < nItems; k++)
	{
		dwItem = dwa_AllItems.GetAt(k);
		dwItemPrev = dwa_AllItems.GetAt(k-1);

		// Skip if not selected or item previous is selected
		if(::CM_DWA_SEEK(dwa_SelectedItems, dwItem) < 0) continue;
		if(::CM_DWA_SEEK(dwa_SelectedItems, (int) dwItemPrev) >= 0) continue;

		dwa_AllItems.SetAt(k, dwItemPrev);
		dwa_AllItems.SetAt(k-1, dwItem);

		bAnyShifted = TRUE;
	}

	// Bail now if nothing done
	if(bAnyShifted == FALSE)
	{
		dwa_AllItems.RemoveAll();
		dwa_SelectedItems.RemoveAll();
		return;
	}

	// Update List Control
	for(k = 0; k < nItems; k++)
	{
		dwItem = dwa_AllItems.GetAt(k);
		if(dwItem == listCtrl.GetItemData(k))
			continue;

		listCtrl.SetItemData(k, dwItem);
		UpdateItemDisplay(k);
		if(::CM_DWA_SEEK(dwa_SelectedItems, (int) dwItem) >= 0)
			listCtrl.SetItemState(k, LVIS_SELECTED, LVIS_SELECTED);
		else
			listCtrl.SetItemState(k, 0, LVIS_SELECTED);
	}


	// Finished
	dwa_AllItems.RemoveAll();
	dwa_SelectedItems.RemoveAll();

}

void CPostMostView::List_MoveSelected_Down()
{
	CListCtrl& listCtrl = GetListCtrl();

	int nItems = listCtrl.GetItemCount();
	int nSelected = listCtrl.GetSelectedCount();

	if((nSelected == 0) || (nItems == 1))
		return;

	int k;
	BOOL bAnyShifted = FALSE;
	DWORD dwItem, dwItemNext;
	CDWordArray dwa_AllItems;
	CDWordArray dwa_SelectedItems;
	dwa_SelectedItems.SetSize(0, nSelected);
	dwa_SelectedItems.SetSize(0, nItems);

	// Collect Item Information
	for(k = 0; k < nItems; k++)
	{
		dwa_AllItems.Add((DWORD) listCtrl.GetItemData(k));
		if(listCtrl.GetItemState(k, LVIS_SELECTED) == LVIS_SELECTED)
			::CM_DWA_INSERT(dwa_SelectedItems, (int) listCtrl.GetItemData(k));
	}

	// Shift Items in dwa varaibles
	for(k = (nItems-2); k >= 0; k--)
	{
		dwItem = dwa_AllItems.GetAt(k);
		dwItemNext = dwa_AllItems.GetAt(k+1);

		// Skip if not selected
		if(::CM_DWA_SEEK(dwa_SelectedItems, dwItem) < 0)
			continue;

		// Skip if item previous is selected
		if(::CM_DWA_SEEK(dwa_SelectedItems, (int) dwItemNext) >= 0)
			continue;

		dwa_AllItems.SetAt(k, dwItemNext);
		dwa_AllItems.SetAt(k+1, dwItem);

		bAnyShifted = TRUE;
	}

	// Bail now if nothing done
	if(bAnyShifted == FALSE)
	{
		dwa_AllItems.RemoveAll();
		dwa_SelectedItems.RemoveAll();
		return;
	}

	// Update List Control
	for(k = 0; k < nItems; k++)
	{
		dwItem = dwa_AllItems.GetAt(k);
		if(dwItem == listCtrl.GetItemData(k))
			continue;

		listCtrl.SetItemData(k, dwItem);
		UpdateItemDisplay(k);
		if(::CM_DWA_SEEK(dwa_SelectedItems, (int) dwItem) >= 0)
			listCtrl.SetItemState(k, LVIS_SELECTED, LVIS_SELECTED);
		else
			listCtrl.SetItemState(k, 0, LVIS_SELECTED);
	}


	// Finished
	dwa_AllItems.RemoveAll();
	dwa_SelectedItems.RemoveAll();
}

void CPostMostView::List_MoveSelected_Top()
{
	CListCtrl& listCtrl = GetListCtrl();

	int nItems = listCtrl.GetItemCount();
	int nSelected = listCtrl.GetSelectedCount();

	if((nSelected == 0) || (nItems == 1))
		return;
	
	int k;
	BOOL bAnyShifted = FALSE;
	DWORD dwItem, dwItemPrev;
	CDWordArray dwa_AllItems;
	CDWordArray dwa_SelectedItems;
	dwa_SelectedItems.SetSize(0, nSelected);
	dwa_SelectedItems.SetSize(0, nItems);

	// Collect Item Information
	for(k = 0; k < nItems; k++)
	{
		dwa_AllItems.Add((DWORD) listCtrl.GetItemData(k));
		if(listCtrl.GetItemState(k, LVIS_SELECTED) == LVIS_SELECTED)
			::CM_DWA_INSERT(dwa_SelectedItems, (int) listCtrl.GetItemData(k));
	}

	// Keep Shifting Items in dwa varaibles up until none are shifted
	int nShifts = 0;
	do
	{
		bAnyShifted = FALSE;

		for(k = 1; k < nItems; k++)
		{
			dwItem = dwa_AllItems.GetAt(k);
			dwItemPrev = dwa_AllItems.GetAt(k-1);

			// Skip if not selected or item previous is selected
			if(::CM_DWA_SEEK(dwa_SelectedItems, dwItem) < 0) continue;
			if(::CM_DWA_SEEK(dwa_SelectedItems, (int) dwItemPrev) >= 0) continue;

			dwa_AllItems.SetAt(k, dwItemPrev);
			dwa_AllItems.SetAt(k-1, dwItem);

			bAnyShifted = TRUE;
			++nShifts;
		}

	} while(bAnyShifted == TRUE);

	// Bail now if nothing done
	if(nShifts == 0)
	{
		dwa_AllItems.RemoveAll();
		dwa_SelectedItems.RemoveAll();
		return;
	}

	// Update List Control
	for(k = 0; k < nItems; k++)
	{
		dwItem = dwa_AllItems.GetAt(k);
		if(dwItem == listCtrl.GetItemData(k))
			continue;

		listCtrl.SetItemData(k, dwItem);
		UpdateItemDisplay(k);
		if(::CM_DWA_SEEK(dwa_SelectedItems, (int) dwItem) >= 0)
			listCtrl.SetItemState(k, LVIS_SELECTED, LVIS_SELECTED);
		else
			listCtrl.SetItemState(k, 0, LVIS_SELECTED);
	}


	// Finished
	dwa_AllItems.RemoveAll();
	dwa_SelectedItems.RemoveAll();
}

void CPostMostView::List_MoveSelected_Bottom()
{
	CListCtrl& listCtrl = GetListCtrl();

	int nItems = listCtrl.GetItemCount();
	int nSelected = listCtrl.GetSelectedCount();

	if((nSelected == 0) || (nItems == 1))
		return;

	int k;
	BOOL bAnyShifted = FALSE;
	DWORD dwItem, dwItemNext;
	CDWordArray dwa_AllItems;
	CDWordArray dwa_SelectedItems;
	dwa_SelectedItems.SetSize(0, nSelected);
	dwa_SelectedItems.SetSize(0, nItems);

	// Collect Item Information
	for(k = 0; k < nItems; k++)
	{
		dwa_AllItems.Add((DWORD) listCtrl.GetItemData(k));
		if(listCtrl.GetItemState(k, LVIS_SELECTED) == LVIS_SELECTED)
			::CM_DWA_INSERT(dwa_SelectedItems, (int) listCtrl.GetItemData(k));
	}

	// Keep Shifting Items in dwa varaibles down until no shifts are made
	int nShifts = 0;
	do
	{
		bAnyShifted = FALSE;
		for(k = (nItems-2); k >= 0; k--)
		{
			dwItem = dwa_AllItems.GetAt(k);
			dwItemNext = dwa_AllItems.GetAt(k+1);

			// Skip if not selected
			if(::CM_DWA_SEEK(dwa_SelectedItems, dwItem) < 0)
				continue;

			// Skip if item previous is selected
			if(::CM_DWA_SEEK(dwa_SelectedItems, (int) dwItemNext) >= 0)
				continue;

			dwa_AllItems.SetAt(k, dwItemNext);
			dwa_AllItems.SetAt(k+1, dwItem);

			bAnyShifted = TRUE;
			++nShifts;
		}

	} while(bAnyShifted == TRUE);

	// Bail now if nothing done
	if(nShifts == 0)
	{
		dwa_AllItems.RemoveAll();
		dwa_SelectedItems.RemoveAll();
		return;
	}

	// Update List Control
	for(k = 0; k < nItems; k++)
	{
		dwItem = dwa_AllItems.GetAt(k);
		if(dwItem == listCtrl.GetItemData(k))
			continue;

		listCtrl.SetItemData(k, dwItem);
		UpdateItemDisplay(k);
		if(::CM_DWA_SEEK(dwa_SelectedItems, (int) dwItem) >= 0)
			listCtrl.SetItemState(k, LVIS_SELECTED, LVIS_SELECTED);
		else
			listCtrl.SetItemState(k, 0, LVIS_SELECTED);
	}


	// Finished
	dwa_AllItems.RemoveAll();
	dwa_SelectedItems.RemoveAll();
}


void CPostMostView::OnUpdateMoveTaskBottom(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable((!m_bRunning) && (GetListCtrl().GetSelectedCount() > 0));
}

void CPostMostView::OnMoveTaskBottom() 
{
	List_MoveSelected_Bottom();
}

void CPostMostView::OnUpdateMoveTaskDown(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable((!m_bRunning) && (GetListCtrl().GetSelectedCount() > 0));
}

void CPostMostView::OnMoveTaskDown() 
{
	List_MoveSelected_Down();
}

void CPostMostView::OnUpdateMoveTaskTop(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable((!m_bRunning) && (GetListCtrl().GetSelectedCount() > 0));
}

void CPostMostView::OnMoveTaskTop() 
{
	List_MoveSelected_Top();
}

void CPostMostView::OnUpdateMoveTaskUp(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable((!m_bRunning) && (GetListCtrl().GetSelectedCount() > 0));
}

void CPostMostView::OnMoveTaskUp() 
{
	List_MoveSelected_Up();
}

void CPostMostView::OnKeydown(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;
	
	if(pLVKeyDow->wVKey == VK_DELETE)
	{
		TRACE("CPostMostView::OnKeydown() - DELETE\n");
		int nItemsTotal = GetListCtrl().GetItemCount();
		int nItemsSelected = GetListCtrl().GetSelectedCount();

		if(nItemsTotal > 0)
		{
			if(nItemsTotal == nItemsSelected)
			{
				PostMessage(WM_COMMAND, ID_FILE_CLEARLIST);
				*pResult = 0;
				return;
			}

			if(nItemsSelected > 0)
				PostMessage(WM_COMMAND, ID_FILE_CLEARSELECTED);
			else
				PostMessage(WM_COMMAND, ID_FILE_CLEARLIST);

			*pResult = 0;
			return;
		}
	}
	
	*pResult = 0;
}

void CPostMostView::OnUpdateFileSetHold(CCmdUI* pCmdUI) 
{
	if((m_bRunning == TRUE) || (GetListCtrl().GetSelectedCount() == 0))
	{
		pCmdUI->Enable(FALSE);
		return;
	}

	// Check to see if any items are NOT marked for PM_HOLDING
	CListCtrl& theList = GetListCtrl();
	int nItems = theList.GetItemCount();
	int kk;
	LVITEM theItem;
	::ZeroMemory(&theItem, sizeof(LVITEM));
	theItem.mask = LVIF_IMAGE;
	CTaskObject* pTaskObject;

	for(kk = 0; kk < nItems; kk++)
	{
		if(theList.GetItemState(kk, LVIS_SELECTED) == LVIS_SELECTED)
		{
			pTaskObject = (CTaskObject*) theList.GetItemData(kk);

			if(pTaskObject->m_nState != CTaskObject::PM_HOLDING)
			{
				pCmdUI->Enable(TRUE);
				return;
			}
		}
	}

	pCmdUI->Enable(FALSE);

}

void CPostMostView::OnFileSetHold() 
{
	// Check to see if any items are marked for QUEUE
	CListCtrl& theList = GetListCtrl();
	int nItems = theList.GetItemCount();
	int kk;

	CTaskObject* pTaskObject;

	for(kk = 0; kk < nItems; kk++)
	{
		if(theList.GetItemState(kk, LVIS_SELECTED) == LVIS_SELECTED)
		{
			pTaskObject = (CTaskObject*) theList.GetItemData(kk);

			if(pTaskObject->m_nState != CTaskObject::PM_HOLDING)
				List_SetItemImageAndState(kk, IMAGE_HOLDING, CTaskObject::PM_HOLDING);
		}
	}
}

/*
	// Set Status Text to Size of Selected items
	CMainFrame* pMainFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;

	TCHAR szStatusText[128];
	sprintf(szStatusText, "%d Files Selected", GetListCtrl().GetSelectedCount());

	pMainFrame->SetStatusText(szStatusText);
*/

