// PosterThread.cpp : implementation file
//

#include "stdafx.h"
#include "PostMost.h"
#include "PosterThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPosterThread

IMPLEMENT_DYNCREATE(CPosterThread, CWinThread)

#define __CM_ENC(c)  ((c) ? ((c) & 077) + ' ' : '`')

CPosterThread::CPosterThread()
{
	m_hSocket = 0;
	m_hWndNotify = (HWND) NULL;
	m_pThreadMarshal = (CThreadMarshal*) NULL;
	m_pTaskObject = (CTaskObject*) NULL;
	m_STOP = FALSE;
	Task_Result_OK = FALSE;
	strcpy(m_NNTP_ConnectString, "");
	// strcpy(Task_Article, "");
	strcpy(Task_Result, "");
	m_nSendBufferSize = 8400;
	m_nSendBufferPos = 0;
}

CPosterThread::~CPosterThread()
{
}

BOOL CPosterThread::InitInstance()
{
	TRACE("CPosterThread::InitInstance() - Connecting To Server\n");

	m_szVersionName.LoadString(IDS_POSTMOST_VERSION);
	m_szVersionInfo.LoadString(IDS_POSTMOST_VERSION_INFO);
	
	m_pThreadMarshal->SetProgress(0,0);	
	SetTask_Article("Connecting To Server ...", 0, 0);
	
	// Connect to server
	if(NNTP_ConnectServer(m_Settings.m_szServerName, m_Settings.m_nServerPort, m_NNTP_ConnectString) == FALSE)
	{
		SetTask_Result(FALSE, m_NNTP_ConnectString);

		if(m_hWndNotify != NULL)
		{
			::PostMessage(m_hWndNotify, WM_THREAD_NO_CONNECTION, 0, 0);
		}
		return TRUE;
	}
	TRACE("%s\n", m_NNTP_ConnectString);

	if(atoi(m_NNTP_ConnectString) / 100 != 2)
	{
		NNTP_DisconnectServer();
		::PostMessage(m_hWndNotify, WM_THREAD_SERVER_NOT_READY, 0, 0);
	}
	else
		::PostMessage(m_hWndNotify, WM_THREAD_READY, 0, 0);

	return TRUE;
}

void CPosterThread::OnMessage_CONNECT(WPARAM wParam, LPARAM lParam)
{
	NNTP_DisconnectServer();

	m_pThreadMarshal->SetProgress(0,0);	
	SetTask_Article("Connecting To Server ...", 0, 0);
	
	// Connect to server
	if(NNTP_ConnectServer(m_Settings.m_szServerName, m_Settings.m_nServerPort, m_NNTP_ConnectString) == FALSE)
	{
		strcpy(m_NNTP_ConnectString, "Error Connecting To Server");
		::PostMessage(m_hWndNotify, WM_THREAD_NO_CONNECTION, 0, 0);
		return;
	}
	TRACE("%s\n", m_NNTP_ConnectString);

	if(atoi(m_NNTP_ConnectString) / 100 != 2)
		::PostMessage(m_hWndNotify, WM_THREAD_SERVER_NOT_READY, 0, 0);
	else
		::PostMessage(m_hWndNotify, WM_THREAD_READY, 0, 0);

}

int CPosterThread::ExitInstance()
{
	TRACE("CPosterThread::ExitInstance\n");
	NNTP_DisconnectServer();

	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CPosterThread, CWinThread)
	//{{AFX_MSG_MAP(CPosterThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
    ON_THREAD_MESSAGE (WM_MSG_POST, OnMessage_POST)
	ON_THREAD_MESSAGE (WM_MSG_QUIT, OnMessage_QUIT)
	ON_THREAD_MESSAGE (WM_MSG_CONNECT, OnMessage_CONNECT)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPosterThread message handlers

void CPosterThread::SetTask_Article(char* szArticle, int nPart, int nPartOf)
{
	m_pThreadMarshal->SetCurrentArticleStatus(szArticle, nPart, nPartOf);
	::PostMessage(m_hWndNotify, WM_THREAD_UPDATE_PROGRESS, 0, 0);

	/*
	if(m_pThreadMarshal->GetLock())
	{
		strcpy(Task_Article, szArticle);
		m_pThreadMarshal->ReleaseLock();
	}
	*/
}

void CPosterThread::SetTask_Result(BOOL bSuccessful, char* szResult)
{
	if(m_pThreadMarshal->GetLock())
	{
		Task_Result_OK = bSuccessful;
		strcpy(Task_Result, szResult);
		if(m_pTaskObject != NULL)
			strcpy(m_pTaskObject->m_szLastResult, szResult);
		m_pThreadMarshal->ReleaseLock();
	}
}

void CPosterThread::SendHeaders(LPCTSTR szArticleSubject, BOOL bIncludeTime, CTime& theServerTime)
{
	TCHAR szArticleFrom[256];

	// Build szArticleFrom string from the From / FromNick settings
	if(strlen(m_Settings.m_szFromNick) > 0)
		sprintf(szArticleFrom, "%s (%s)", m_Settings.m_szFrom, m_Settings.m_szFromNick);
	else
		strcpy(szArticleFrom, m_Settings.m_szFrom);

	TCHAR szLine[512];

	// Send "From:" Header
	sprintf(szLine, "From: %s\r\nSender: %s\r\n", szArticleFrom, m_Settings.m_szFrom);
	NNTP_SendLine(szLine);

	// Send "Newsgroups:" header
	sprintf(szLine, "Newsgroups: ");
	strcat(szLine, (LPCTSTR) m_pTaskObject->m_strGroups);
	strcat(szLine, "\r\n");
	NNTP_SendLine(szLine);

	// Send "Subject:" header
	sprintf(szLine, "Subject: %s\r\n", szArticleSubject);
	NNTP_SendLine(szLine);
	
	// Send "Organization:" header (optional)
	if(strlen(m_Settings.m_szOrganization) > 0)
	{
		sprintf(szLine, "Organization: %s\r\n", m_Settings.m_szOrganization);
		NNTP_SendLine(szLine);
	}

	// Send "Reply-To:" header (optional)
	if(strlen(m_Settings.m_szReplyTo) > 0)
	{
		sprintf(szLine, "Reply-To: %s\r\n", m_Settings.m_szReplyTo);
		NNTP_SendLine(szLine);
	}

	// Send "Followup-To:" header (optional)
	if(strlen(m_Settings.m_szFollowupTo) > 0)
	{
		sprintf(szLine, "Followup-To: %s\r\n", m_Settings.m_szFollowupTo);
		NNTP_SendLine(szLine);
	}

	NNTP_SendLine(m_Settings.m_szXBinaryPoster);

	// Include X-No-Archive header if option set
	if(m_Settings.m_bXNoArchiveHeader)
	{
		sprintf(szLine, "X-No-Archive: yes\r\n");
		NNTP_SendLine(szLine);
	}

	// Some NNTP Servers may not support the 'DATE' command extension
	if(bIncludeTime)
	{
		// X-Server-Date: 26 May 2000 12:51:42 GMT
		switch(theServerTime.GetMonth())
		{
		case 1: sprintf(szLine, "X-Server-Date: %02d Jan %04d %02d:%02d:%02d GMT\r\n", theServerTime.GetDay(), theServerTime.GetYear(), 
					theServerTime.GetHour(), theServerTime.GetMinute(), theServerTime.GetSecond());
				NNTP_SendLine(szLine);
				break;
		case 2: sprintf(szLine, "X-Server-Date: %02d Feb %04d %02d:%02d:%02d GMT\r\n", theServerTime.GetDay(), theServerTime.GetYear(), 
					theServerTime.GetHour(), theServerTime.GetMinute(), theServerTime.GetSecond());
				NNTP_SendLine(szLine);
				break;
		case 3: sprintf(szLine, "X-Server-Date: %02d Mar %04d %02d:%02d:%02d GMT\r\n", theServerTime.GetDay(), theServerTime.GetYear(), 
					theServerTime.GetHour(), theServerTime.GetMinute(), theServerTime.GetSecond());
				NNTP_SendLine(szLine);
				break;
		case 4: sprintf(szLine, "X-Server-Date: %02d Apr %04d %02d:%02d:%02d GMT\r\n", theServerTime.GetDay(), theServerTime.GetYear(), 
					theServerTime.GetHour(), theServerTime.GetMinute(), theServerTime.GetSecond());
				NNTP_SendLine(szLine);
				break;
		case 5: sprintf(szLine, "X-Server-Date: %02d May %04d %02d:%02d:%02d GMT\r\n", theServerTime.GetDay(), theServerTime.GetYear(), 
					theServerTime.GetHour(), theServerTime.GetMinute(), theServerTime.GetSecond());
				NNTP_SendLine(szLine);
				break;
		case 6: sprintf(szLine, "X-Server-Date: %02d Jun %04d %02d:%02d:%02d GMT\r\n", theServerTime.GetDay(), theServerTime.GetYear(), 
					theServerTime.GetHour(), theServerTime.GetMinute(), theServerTime.GetSecond());
				NNTP_SendLine(szLine);
				break;
		case 7: sprintf(szLine, "X-Server-Date: %02d Jul %04d %02d:%02d:%02d GMT\r\n", theServerTime.GetDay(), theServerTime.GetYear(), 
					theServerTime.GetHour(), theServerTime.GetMinute(), theServerTime.GetSecond());
				NNTP_SendLine(szLine);
				break;
		case 8: sprintf(szLine, "X-Server-Date: %02d Aug %04d %02d:%02d:%02d GMT\r\n", theServerTime.GetDay(), theServerTime.GetYear(), 
					theServerTime.GetHour(), theServerTime.GetMinute(), theServerTime.GetSecond());
				NNTP_SendLine(szLine);
				break;
		case 9: sprintf(szLine, "X-Server-Date: %02d Sep %04d %02d:%02d:%02d GMT\r\n", theServerTime.GetDay(), theServerTime.GetYear(), 
					theServerTime.GetHour(), theServerTime.GetMinute(), theServerTime.GetSecond());
				NNTP_SendLine(szLine);
				break;
		case 10: sprintf(szLine, "X-Server-Date: %02d Oct %04d %02d:%02d:%02d GMT\r\n", theServerTime.GetDay(), theServerTime.GetYear(), 
					theServerTime.GetHour(), theServerTime.GetMinute(), theServerTime.GetSecond());
				NNTP_SendLine(szLine);
				break;
		case 11: sprintf(szLine, "X-Server-Date: %02d Nov %04d %02d:%02d:%02d GMT\r\n", theServerTime.GetDay(), theServerTime.GetYear(), 
					theServerTime.GetHour(), theServerTime.GetMinute(), theServerTime.GetSecond());
				NNTP_SendLine(szLine);
				break;
		case 12: sprintf(szLine, "X-Server-Date: %02d Dec %04d %02d:%02d:%02d GMT\r\n", theServerTime.GetDay(), theServerTime.GetYear(), 
					theServerTime.GetHour(), theServerTime.GetMinute(), theServerTime.GetSecond());
				NNTP_SendLine(szLine);
				break;

		}
	}

	sprintf(szLine, "\r\n\r\n");
	NNTP_SendLine(szLine);
}

void CPosterThread::OnMessage_QUIT(WPARAM wParam, LPARAM lParam)
{
	TRACE("CPosterThread::OnMessage_QUIT()\n");
	PostQuitMessage(0);
}

void CPosterThread::OnMessage_POST(WPARAM wParam, LPARAM lParam)
{
	TRACE("CPosterThread::OnMessage_POST()\n");

	CFile theFile;
	CFileException cfe;
	int nResultCode;
	int nFileSizeK;
	int nLines, nParts, curPart;
	DWORD nFileSizeBytes;
	int nBatchLinesInc;
	char szArticle[1024];
	char szLine[1024];
	TCHAR szLOG[1024];

	m_pTaskObject->SetModified();

	if(theFile.Open(m_pTaskObject->m_szFilename, CFile::modeRead | CFile::shareDenyNone, &cfe) == FALSE)
	{
		switch(cfe.m_cause)
		{
		case CFileException::generic:			SetTask_Result(FALSE, "File Open Error (Generic)"); m_pTaskObject->m_Log.Add("File Open Error (Generic)"); break;
		case CFileException::fileNotFound:		SetTask_Result(FALSE, "File Open Error (File Not Found)"); m_pTaskObject->m_Log.Add("File Open Error (File Not Found)"); break;
		case CFileException::badPath:			SetTask_Result(FALSE, "File Open Error (Bad Path)"); m_pTaskObject->m_Log.Add("File Open Error (Bad Path)"); break;
		case CFileException::tooManyOpenFiles:	SetTask_Result(FALSE, "File Open Error (Too Many Open Files)"); m_pTaskObject->m_Log.Add("File Open Error (Too Many Open Files)"); break;
		case CFileException::accessDenied:		SetTask_Result(FALSE, "File Open Error (Access Denied)"); m_pTaskObject->m_Log.Add("File Open Error (Access Denied)"); break;
		case CFileException::invalidFile:		SetTask_Result(FALSE, "File Open Error (Invalid File)"); m_pTaskObject->m_Log.Add("File Open Error (Invalid File)"); break;
		case CFileException::removeCurrentDir:	SetTask_Result(FALSE, "File Open Error (Removed Current Dir)"); m_pTaskObject->m_Log.Add("File Open Error (Removed Current Dir)"); break;
		case CFileException::directoryFull:		SetTask_Result(FALSE, "File Open Error (Directory Full)"); m_pTaskObject->m_Log.Add("File Open Error (Directory Full)"); break;
		case CFileException::badSeek:			SetTask_Result(FALSE, "File Open Error (Bad Seek)"); m_pTaskObject->m_Log.Add("File Open Error (Bad Seek)"); break;
		case CFileException::hardIO:			SetTask_Result(FALSE, "File Open Error (Hard IO Error)"); m_pTaskObject->m_Log.Add("File Open Error (Hard IO Error)"); break;
		case CFileException::sharingViolation:	SetTask_Result(FALSE, "File Open Error (Sharing Violation)"); m_pTaskObject->m_Log.Add("File Open Error (Sharing Violation)"); break;
		case CFileException::lockViolation:		SetTask_Result(FALSE, "File Open Error (Lock Violation)"); m_pTaskObject->m_Log.Add("File Open Error (Lock Violation)"); break;
		case CFileException::diskFull:			SetTask_Result(FALSE, "File Open Error (Disk Full)"); m_pTaskObject->m_Log.Add("File Open Error (Disk Full)"); break;
		case CFileException::endOfFile:			SetTask_Result(FALSE, "File Open Error (End Of File)"); m_pTaskObject->m_Log.Add("File Open Error (End Of File)"); break;
		default: SetTask_Result(FALSE, "File Open Error (Unknown Cause)"); break;
		}
		sprintf(szLOG, " --> Article '%s' Not Posted!", m_pTaskObject->m_szSubject);
		m_pTaskObject->m_Log.Add(szLOG);
		if(m_STOP == TRUE) return;
		NNTP_DisconnectServer();
		if(m_hWndNotify != NULL) ::PostMessage(m_hWndNotify, WM_THREAD_NO_CONNECTION, 0, 0);
		return;
	}

	m_pThreadMarshal->SetCurrentTargetNewsgroups((LPCTSTR) m_pTaskObject->m_strGroups);

	// Get File Size and Calculate Number of Parts
	nFileSizeBytes = theFile.GetLength();
	
	nFileSizeK = ((nFileSizeBytes-1) / 1024) + 1;

	nLines = (int) (nFileSizeBytes / YENCLEN);
	if((nFileSizeBytes % YENCLEN) > 0) ++nLines;

	nParts = nLines / m_pTaskObject->m_nMaxLines;
	if((nLines % m_pTaskObject->m_nMaxLines) > 0)
		++nParts;

	CString szBaseFilename, szPathToFile;
	_BreakFilename(m_pTaskObject->m_szFilename, szPathToFile, szBaseFilename);

	TRACE3("File Size = %d  -  Total Lines = %d  -  Number of Parts To Post: %d\n", nFileSizeBytes, nLines, nParts);

	int nLinesSentTotal = 0;
	int nLinesSentThisPart = 0;
	double d_TOT, d_DON, d_POS;
	int nProgressPart;
	int nProgressTotal;

	BOOL  bXServerDate = FALSE;
	CTime tmServerDate;

	// Send Prefix Text (0/n) article if there is anything in m_pTaskObject->m_strTextPrefix
	LPCTSTR pText = NULL;
	int lpos;

	BOOL bPostPrefixText = FALSE;
	if((m_pTaskObject->m_strTextPrefix.GetLength() > 0) && (m_pTaskObject->m_bPostPrefixText == TRUE))
		bPostPrefixText = TRUE;

	if( (m_pTaskObject->m_dwaPartsToPost.GetSize() == 0) && (bPostPrefixText == FALSE))
	{
		SetTask_Result(FALSE, "No Parts Flagged To Post!"); 
		m_pTaskObject->m_Log.Add("Queued, But No Parts Flagged For Posting");
		if(m_hWndNotify != NULL)
			::PostMessage(m_hWndNotify, WM_THREAD_READY, 0, 0);
		return;
	}

	if(m_Settings.m_bXServerDate)
	{
		for (int i=0;i<2;i++) {
			if(NNTP_SendLine("DATE\r\n"))
			{
				if(!NNTP_GetLine(szLine, 1023))
				{
					theFile.Close();
					SetTask_Result(FALSE, "Error Sending POST Command To Server");
					m_pTaskObject->m_Log.Add("Error Sending POST Command!");
					sprintf(szLOG, "  --> Article '%s' Not Posted!", szArticle);
					m_pTaskObject->m_Log.Add(szLOG);
					NNTP_DisconnectServer();
					if(m_STOP == TRUE) return;
					if(m_hWndNotify != NULL) ::PostMessage(m_hWndNotify, WM_THREAD_NO_CONNECTION, 0, 0);
					return;
				}

				nResultCode = atoi(szLine);

				if (nResultCode==480&&Authenticate(szLOG)) continue;
		
				if(nResultCode == 111)
				{
					// szLine should look like this:
					// 111 20000526212626
					// Which is GMT for Year 2000 Month 05 Day 26 Hour 21 Min 26 Sec 26
					if(ParseServerDate(tmServerDate, (LPCTSTR) (szLine + 4)))
						bXServerDate = TRUE;
				}
			}
			break;
		}

	}

	if(bPostPrefixText)
	{
		CM_BuildArticleName(szArticle, m_pTaskObject->m_szSubject, m_pTaskObject->m_szFilename, 0, nParts);
		SetTask_Article(szArticle, 0, nParts);

		TRACE("Posting Article: %s\n", szArticle);

		TRACE("Sending 'post' command...\n");

		for (int i=0;i<2;i++) {
			if(!NNTP_SendLine("post\r\n"))
			{
				theFile.Close();
				SetTask_Result(FALSE, "Error Sending POST Command To Server");
				m_pTaskObject->m_Log.Add("Error Sending POST Command!");
				sprintf(szLOG, "  --> Article '%s' Not Posted!", szArticle);
				m_pTaskObject->m_Log.Add(szLOG);
				NNTP_DisconnectServer();
				if(m_STOP == TRUE) return;
				if(m_hWndNotify != NULL) ::PostMessage(m_hWndNotify, WM_THREAD_NO_CONNECTION, 0, 0);
				return;
			}

			TRACE("Getting 'post' command Response...\n");

			if(!NNTP_GetLine(szLine, 1023))
			{
				theFile.Close();
				SetTask_Result(FALSE, "Error Receiving POST Command Response From Server");
				m_pTaskObject->m_Log.Add("Error Receiving POST Command Response!");
				sprintf(szLOG, "  --> Article '%s' Not Posted!", szArticle);
				m_pTaskObject->m_Log.Add(szLOG);
				NNTP_DisconnectServer();
				if(m_STOP == TRUE) return;
				if(m_hWndNotify != NULL) ::PostMessage(m_hWndNotify, WM_THREAD_NO_CONNECTION, 0, 0);
				return;
			}

			TRACE1("Got Post Command Response: %s\n", szLine);

			nResultCode = atoi(szLine);

			if (nResultCode==480&&Authenticate(szLOG)) continue;

			if(nResultCode != 340)
			{
				theFile.Close();
				SetTask_Result(FALSE, szLine);
				sprintf(szLOG, "POST Command Response Error: %s", szLine);
				m_pTaskObject->m_Log.Add(szLOG);
				sprintf(szLOG, "  --> Article '%s' Not Posted!", szArticle);
				m_pTaskObject->m_Log.Add(szLOG);
				NNTP_DisconnectServer();
				if(m_hWndNotify != NULL) ::PostMessage(m_hWndNotify, WM_THREAD_NO_CONNECTION, 0, 0);
				return;
			}
			break;
		}

		// Send Article Header (From:, Newsgroups:, Subject:, Organization:)
		TRACE("Sending Article Header...\n");

		SendHeaders(szArticle, bXServerDate, tmServerDate);

		// Post Text
		pText = (LPCTSTR) m_pTaskObject->m_strTextPrefix;
		while(*pText != '\0')
		{
			sprintf(szLine, "");
			lpos = 0;

			while((*pText != '\0') && (*pText != '\r') && (*pText != '\n'))
			{
				szLine[lpos] = *pText;
				++pText;
				++lpos;
				if((lpos == 1) && (*pText == '.'))
				{
					szLine[lpos] = '.';	// Double-up periods if lines starts with one
					++lpos;
				}
			}
			szLine[lpos] = '\0';
			strcat(szLine, "\r\n");
			
			// if(strcmp(szLine, ".\r\n") == 0)
			//	sprintf(szLine, "..\r\n");

			NNTP_SendLine(szLine);

			if(*pText == '\r') ++pText;
			if(*pText == '\n') ++pText;
		}

		// Finish Message
		NNTP_SendLine(".\r\n");

		// Get Reponse To Article Post
		TRACE("Done - Waiting For Server Response To Article Post\n");

		if(!NNTP_GetLine(szLine, 1023))
		{
			theFile.Close();
			SetTask_Result(FALSE, "Error Receiving POST Acknowledgement From Server");
			m_pTaskObject->m_Log.Add("Error Receiving POST Acknowledgement From Server");
			sprintf(szLOG, "  --> Article '%s' Not Posted!", szArticle);
			m_pTaskObject->m_Log.Add(szLOG);
			NNTP_DisconnectServer();
			if(m_STOP == TRUE) return;
			if(m_hWndNotify != NULL) ::PostMessage(m_hWndNotify, WM_THREAD_NO_CONNECTION, 0, 0);
			return;
		}

		TRACE("Response Received: %s\n", szLine);
		nResultCode = atoi(szLine);

		if(nResultCode != 240)
		{
			theFile.Close();
			SetTask_Result(FALSE, szLine);
			sprintf(szLOG, "POST Failed: %s", szLine);
			m_pTaskObject->m_Log.Add(szLOG);
			sprintf(szLOG, "  --> Article '%s' Not Posted!", szArticle);
			m_pTaskObject->m_Log.Add(szLOG);
			NNTP_DisconnectServer();
			if(m_hWndNotify != NULL) ::PostMessage(m_hWndNotify, WM_THREAD_NO_CONNECTION, 0, 0);
			return;
		}
		
		sprintf(szLOG, "%s: %s", szLine, szArticle);
		m_pTaskObject->m_Log.Add(szLOG);
		m_pTaskObject->m_bPostPrefixText = FALSE;

		strcpy(szLine, "Part 0 Posted");
	}

	nBatchLinesInc = 0;
	int nMaxLinesThisPart;
	int nFileSeekPos;

	while(m_pTaskObject->m_dwaPartsToPost.GetSize() > 0)
	{
		if(m_STOP) break;

		curPart = m_pTaskObject->m_dwaPartsToPost.GetAt(0);

		CM_BuildArticleName(szArticle, m_pTaskObject->m_szSubject, m_pTaskObject->m_szFilename, curPart, nParts);

		SetTask_Article(szArticle, curPart, nParts);

		TRACE("Posting Article: %s\n", szArticle);

		TRACE("Sending 'post' command...\n");

		for (int i=0;i<2;i++) {
			if(!NNTP_SendLine("post\r\n"))
			{
				theFile.Close();
				SetTask_Result(FALSE, "Error Sending POST Command To Server");
				m_pTaskObject->m_Log.Add("Error Sending POST Command!");
				sprintf(szLOG, "  --> Article '%s' Not Posted!", szArticle);
				m_pTaskObject->m_Log.Add(szLOG);
				NNTP_DisconnectServer();
				if(m_STOP == TRUE) return;
				if(m_hWndNotify != NULL) ::PostMessage(m_hWndNotify, WM_THREAD_NO_CONNECTION, 0, 0);
				return;
			}

			TRACE("Getting 'post' command Response...\n");

			if(!NNTP_GetLine(szLine, 1023))
			{
				theFile.Close();
				SetTask_Result(FALSE, "Error Receiving POST Command Response From Server");
				m_pTaskObject->m_Log.Add("Error Receiving POST Command Response!");
				sprintf(szLOG, "  --> Article '%s' Not Posted!", szArticle);
				m_pTaskObject->m_Log.Add(szLOG);
				NNTP_DisconnectServer();
				if(m_STOP == TRUE) return;
				if(m_hWndNotify != NULL) ::PostMessage(m_hWndNotify, WM_THREAD_NO_CONNECTION, 0, 0);
				return;
			}

			TRACE1("Got Post Command Response: %s\n", szLine);

			nResultCode = atoi(szLine);

			if (nResultCode==480&&Authenticate(szLOG)) continue;

			if(nResultCode != 340)
			{
				theFile.Close();
				SetTask_Result(FALSE, szLine);
				sprintf(szLOG, "POST Command Response Error: %s", szLine);
				m_pTaskObject->m_Log.Add(szLOG);
				sprintf(szLOG, "  --> Article '%s' Not Posted!", szArticle);
				m_pTaskObject->m_Log.Add(szLOG);
				NNTP_DisconnectServer();
				if(m_hWndNotify != NULL) ::PostMessage(m_hWndNotify, WM_THREAD_NO_CONNECTION, 0, 0);
				return;
			}
			break;
		}

		// Send Article Header (From:, Newsgroups:, Subject:, Organization:)
		TRACE("Sending Article Header...\n");

		SendHeaders(szArticle, bXServerDate, tmServerDate);

		nLinesSentThisPart = 0;
		
		// Seek to correct position in file
		nFileSeekPos = (curPart - 1) * YENCLEN * m_pTaskObject->m_nMaxLines;
		theFile.Seek(nFileSeekPos, CFile::begin);
		nMaxLinesThisPart = m_pTaskObject->m_nMaxLines;

		nLinesSentThisPart = 0;
		
		CString str;

		const int LOUTBUF=YENCLEN+1;
		char obuf[LOUTBUF+3];

		const int LINBUF=10000;
		unsigned char ibuf[LINBUF];

		static const int yenc_crc_tab[256] = {
			0x00000000, 0x77073096, 0xee0e612c, 0x990951ba, 0x076dc419, 0x706af48f, 0xe963a535, 0x9e6495a3,
			0x0edb8832, 0x79dcb8a4, 0xe0d5e91e, 0x97d2d988, 0x09b64c2b, 0x7eb17cbd, 0xe7b82d07, 0x90bf1d91,
			0x1db71064, 0x6ab020f2, 0xf3b97148, 0x84be41de, 0x1adad47d, 0x6ddde4eb, 0xf4d4b551, 0x83d385c7,
			0x136c9856, 0x646ba8c0, 0xfd62f97a, 0x8a65c9ec, 0x14015c4f, 0x63066cd9, 0xfa0f3d63, 0x8d080df5,
			0x3b6e20c8, 0x4c69105e, 0xd56041e4, 0xa2677172, 0x3c03e4d1, 0x4b04d447, 0xd20d85fd, 0xa50ab56b,
			0x35b5a8fa, 0x42b2986c, 0xdbbbc9d6, 0xacbcf940, 0x32d86ce3, 0x45df5c75, 0xdcd60dcf, 0xabd13d59,
			0x26d930ac, 0x51de003a, 0xc8d75180, 0xbfd06116, 0x21b4f4b5, 0x56b3c423, 0xcfba9599, 0xb8bda50f,
			0x2802b89e, 0x5f058808, 0xc60cd9b2, 0xb10be924, 0x2f6f7c87, 0x58684c11, 0xc1611dab, 0xb6662d3d,
			0x76dc4190, 0x01db7106, 0x98d220bc, 0xefd5102a, 0x71b18589, 0x06b6b51f, 0x9fbfe4a5, 0xe8b8d433,
			0x7807c9a2, 0x0f00f934, 0x9609a88e, 0xe10e9818, 0x7f6a0dbb, 0x086d3d2d, 0x91646c97, 0xe6635c01,
			0x6b6b51f4, 0x1c6c6162, 0x856530d8, 0xf262004e, 0x6c0695ed, 0x1b01a57b, 0x8208f4c1, 0xf50fc457,
			0x65b0d9c6, 0x12b7e950, 0x8bbeb8ea, 0xfcb9887c, 0x62dd1ddf, 0x15da2d49, 0x8cd37cf3, 0xfbd44c65,
			0x4db26158, 0x3ab551ce, 0xa3bc0074, 0xd4bb30e2, 0x4adfa541, 0x3dd895d7, 0xa4d1c46d, 0xd3d6f4fb,
			0x4369e96a, 0x346ed9fc, 0xad678846, 0xda60b8d0, 0x44042d73, 0x33031de5, 0xaa0a4c5f, 0xdd0d7cc9,
			0x5005713c, 0x270241aa, 0xbe0b1010, 0xc90c2086, 0x5768b525, 0x206f85b3, 0xb966d409, 0xce61e49f,
			0x5edef90e, 0x29d9c998, 0xb0d09822, 0xc7d7a8b4, 0x59b33d17, 0x2eb40d81, 0xb7bd5c3b, 0xc0ba6cad,
			0xedb88320, 0x9abfb3b6, 0x03b6e20c, 0x74b1d29a, 0xead54739, 0x9dd277af, 0x04db2615, 0x73dc1683,
			0xe3630b12, 0x94643b84, 0x0d6d6a3e, 0x7a6a5aa8, 0xe40ecf0b, 0x9309ff9d, 0x0a00ae27, 0x7d079eb1,
			0xf00f9344, 0x8708a3d2, 0x1e01f268, 0x6906c2fe, 0xf762575d, 0x806567cb, 0x196c3671, 0x6e6b06e7,
			0xfed41b76, 0x89d32be0, 0x10da7a5a, 0x67dd4acc, 0xf9b9df6f, 0x8ebeeff9, 0x17b7be43, 0x60b08ed5,
			0xd6d6a3e8, 0xa1d1937e, 0x38d8c2c4, 0x4fdff252, 0xd1bb67f1, 0xa6bc5767, 0x3fb506dd, 0x48b2364b,
			0xd80d2bda, 0xaf0a1b4c, 0x36034af6, 0x41047a60, 0xdf60efc3, 0xa867df55, 0x316e8eef, 0x4669be79,
			0xcb61b38c, 0xbc66831a, 0x256fd2a0, 0x5268e236, 0xcc0c7795, 0xbb0b4703, 0x220216b9, 0x5505262f,
			0xc5ba3bbe, 0xb2bd0b28, 0x2bb45a92, 0x5cb36a04, 0xc2d7ffa7, 0xb5d0cf31, 0x2cd99e8b, 0x5bdeae1d,
			0x9b64c2b0, 0xec63f226, 0x756aa39c, 0x026d930a, 0x9c0906a9, 0xeb0e363f, 0x72076785, 0x05005713,
			0x95bf4a82, 0xe2b87a14, 0x7bb12bae, 0x0cb61b38, 0x92d28e9b, 0xe5d5be0d, 0x7cdcefb7, 0x0bdbdf21,
			0x86d3d2d4, 0xf1d4e242, 0x68ddb3f8, 0x1fda836e, 0x81be16cd, 0xf6b9265b, 0x6fb077e1, 0x18b74777,
			0x88085ae6, 0xff0f6a70, 0x66063bca, 0x11010b5c, 0x8f659eff, 0xf862ae69, 0x616bffd3, 0x166ccf45,
			0xa00ae278, 0xd70dd2ee, 0x4e048354, 0x3903b3c2, 0xa7672661, 0xd06016f7, 0x4969474d, 0x3e6e77db,
			0xaed16a4a, 0xd9d65adc, 0x40df0b66, 0x37d83bf0, 0xa9bcae53, 0xdebb9ec5, 0x47b2cf7f, 0x30b5ffe9,
			0xbdbdf21c, 0xcabac28a, 0x53b39330, 0x24b4a3a6, 0xbad03605, 0xcdd70693, 0x54de5729, 0x23d967bf,
			0xb3667a2e, 0xc4614ab8, 0x5d681b02, 0x2a6f2b94, 0xb40bbe37, 0xc30c8ea1, 0x5a05df1b, 0x2d02ef8d
		};

		int size=theFile.GetLength();
		int cur_ibuf=LINBUF;
		int chars_per_part=YENCLEN*nMaxLinesThisPart;

		int pos=nFileSeekPos+1;
		int chars_in_part = size-pos+1>chars_per_part ? chars_per_part : size-pos+1;
		
		// Begin the UUENCODING if this is Part 1

		// NNTP_SendLine((char*) (LPCTSTR) m_szVersionName);
		// NNTP_SendLine((char*) (LPCTSTR) m_szVersionInfo);
		// NNTP_SendLine("\r\n");
		str.Format("=ybegin part=%d line=%d size=%u name=%s\r\n=ypart begin=%u end=%u\r\n",
 		            curPart,YENCLEN,size,szBaseFilename,pos,pos+chars_in_part-1);
		NNTP_SendLine((LPTSTR)((LPCTSTR)str));

		if(nFileSeekPos + (YENCLEN * m_pTaskObject->m_nMaxLines) > (int) m_pTaskObject->m_dwFileSize)
			nMaxLinesThisPart = ((m_pTaskObject->m_dwFileSize - nFileSeekPos) / YENCLEN) + 1;

		unsigned int crc32=0xFFFFFFFF;

		for (int count=0;count<chars_in_part;) {
			if(m_STOP) break;
			for (int l=0;l<YENCLEN&&count<chars_in_part;l++) {
				if (cur_ibuf==LINBUF) {
					cur_ibuf=0;
					theFile.Read(ibuf,LINBUF);
				}
				unsigned char c=ibuf[cur_ibuf++];

				unsigned int ch=yenc_crc_tab[(crc32 ^ c) & 0xFF];
				crc32=ch ^ crc32>>8;

				c+=42;
				switch (c) {
				case 0:
				case '\r':
				case '\n':
				case '=':
					obuf[l++]='=';
					c+=64;
				}
				obuf[l]=c;
	
				count++;
			}
			obuf[l++]='\r';
			obuf[l++]='\n';
			obuf[l]=0;
			if (obuf[0]=='.') NNTP_SendLine(".");
			NNTP_SendLine(obuf);
			++nLinesSentTotal;
			++nBatchLinesInc;
			++nLinesSentThisPart;

			if((count % 256) == 1)
			{
				d_TOT = (double) nMaxLinesThisPart;
				d_DON = (double) nLinesSentThisPart;
				d_POS = (d_DON / d_TOT) * (double) 100.0;
				nProgressPart = (int) d_POS;
				d_TOT = (double) m_pTaskObject->m_dwFileSize;
				d_DON = (double) theFile.GetPosition();
				d_POS = (d_DON / d_TOT) * (double) 100.0;
				nProgressTotal = (int) d_POS;
				m_pThreadMarshal->SetProgress(nProgressTotal, nProgressPart);
				m_pThreadMarshal->IncrementBatchPos(nBatchLinesInc); 
				nBatchLinesInc = 0;
			}
		}

		if(m_STOP) break;

		m_pThreadMarshal->IncrementBatchPos(nBatchLinesInc); nBatchLinesInc = 0;

		// Update Progress every now and then...
		if(curPart < nParts)
		{
			d_TOT = (double) m_pTaskObject->m_nMaxLines;
			d_DON = (double) nLinesSentThisPart;
			d_POS = (d_DON / d_TOT) * (double) 100.0;
			nProgressPart = (int) d_POS;
			m_pThreadMarshal->SetProgress(nProgressTotal, 100);
			::Sleep(0);
			if(m_Settings.m_bSound) PlaySound((LPCTSTR) IDR_WAVE_DRIP, NULL, SND_ASYNC | SND_RESOURCE | SND_NOSTOP);
		}

		if(curPart == nParts)
		{
			m_pThreadMarshal->SetProgress(100, 100);
		}

		str.Format("=yend size=%u part=%d pcrc32=%08x\r\n",
		           chars_in_part,curPart,crc32^0xFFFFFFFF);

		NNTP_SendLine((LPTSTR)((LPCTSTR)str));

		// Finish Message
		NNTP_SendLine(".\r\n");

		// Get Reponse To Article Post
		TRACE("Done - Waiting For Server Response To Article Post\n");

		if(!NNTP_GetLine(szLine, 1023))
		{
			theFile.Close();
			if(m_STOP)
			{
				SetTask_Result(FALSE, "Stopped By User");
				m_pTaskObject->m_Log.Add("Stopped By User");
				sprintf(szLOG, "  --> Article '%s' Not Posted!", szArticle);
				m_pTaskObject->m_Log.Add(szLOG);
				return;
			}
			SetTask_Result(FALSE, "Error Receiving POST Acknowledgement From Server");
			m_pTaskObject->m_Log.Add("Error Receiving POST Acknowledgement From Server");
			sprintf(szLOG, "  --> Article '%s' Not Posted!", szArticle);
			m_pTaskObject->m_Log.Add(szLOG);
			NNTP_DisconnectServer();
			if(m_STOP == TRUE) return;
			m_pThreadMarshal->DecrementBatchPos(nLinesSentThisPart);
			if(m_hWndNotify != NULL) ::PostMessage(m_hWndNotify, WM_THREAD_NO_CONNECTION, 0, 0);
			return;
		}

		TRACE("Response Received: %s\n", szLine);
		nResultCode = atoi(szLine);

		if(nResultCode != 240)
		{
			theFile.Close();
			SetTask_Result(FALSE, szLine);
			sprintf(szLOG, "POST Failed: %s", szLine);
			m_pTaskObject->m_Log.Add(szLOG);
			sprintf(szLOG, "  --> Article '%s' Not Posted!", szArticle);
			m_pTaskObject->m_Log.Add(szLOG);
			NNTP_DisconnectServer();
			m_pThreadMarshal->DecrementBatchPos(nLinesSentThisPart);
			if(m_hWndNotify != NULL) ::PostMessage(m_hWndNotify, WM_THREAD_NO_CONNECTION, 0, 0);
			return;
		}

		sprintf(szLOG, "%s: %s", szLine, szArticle);
		m_pTaskObject->m_Log.Add(szLOG);
		m_pTaskObject->m_dwaPartsToPost.RemoveAt(0);

		if(m_STOP) break;

	}

	theFile.Close();

	m_pThreadMarshal->SetProgress(0,0);

	if((m_STOP == TRUE) && (m_pTaskObject->m_dwaPartsToPost.GetSize() > 0))
		SetTask_Result(FALSE, "Stopped By User");
	else 
		SetTask_Result(TRUE, szLine);

	if(m_hWndNotify != NULL) ::PostMessage(m_hWndNotify, WM_THREAD_READY, 0, m_STOP);

}

int CPosterThread::NNTP_GetLine(char* p, int MaxChar)
{
	char ch = 0;
	int n = 0;
	int rv;

	NNTP_FlushOutputBuffer();

	for(;;)
	{
		rv = recv(m_hSocket, &ch, 1, 0);
		if(rv == SOCKET_ERROR) { TRACE("\n"); return(0); }
		if(rv == 0)	break;

		TRACE2(" RCV: '%c' (%d)", ch, (UINT) ch);
		if(n % 8 == 7) TRACE("\n");

		if(ch == 0x0D) { p[n] = '\0'; break; }
		if((ch >= 0x20) || (ch == 0x09)) { p[n] = ch; ++n; }
		if(n >= MaxChar) { p[MaxChar] = '\0'; TRACE("\n"); return(MaxChar); }
	}
	TRACE("\n");
	return(n);
}

int CPosterThread::NNTP_SendLine(char* p)
{
	// m_nSendBufferSize = 8400;
	// m_nSendBufferPos = 0;

	// Get size of text to transmit
	int sl = strlen(p);	
	if(sl == 0) return(0);

	// Check to see if buffer will hold it
	if( (sl + m_nSendBufferPos) < m_nSendBufferSize)
	{
		// Yes.. just add it to the buffer..
		::CopyMemory(&m_szSendBuffer[m_nSendBufferPos], p, sl);
		m_nSendBufferPos += sl;
		return(sl);
	}

	// No room.. flush the buffer and set the new buffer contents..
	NNTP_FlushOutputBuffer();

	// Special Case: Send data now if it won't fit in buffer
	if(sl > m_nSendBufferSize)
	{
		m_pThreadMarshal->TransmissionNotify(sl);
		return(send(m_hSocket, p, sl, 0));
	}

	// OK, it fits.. Set send buffer to contents (we just flushed it)
	::CopyMemory(m_szSendBuffer, p, sl);
	m_nSendBufferPos = sl;
	return(sl);
}

int CPosterThread::NNTP_FlushOutputBuffer()
{
	// Is there anything in the buffer?
	if(m_nSendBufferPos > 0)
	{
		// Yes..
		int nRetVal;
		m_pThreadMarshal->TransmissionNotify(m_nSendBufferPos);
		nRetVal = send(m_hSocket, m_szSendBuffer, m_nSendBufferPos, 0);
		m_nSendBufferPos = 0;
	}
	return(0);
}

BOOL CPosterThread::Authenticate(char* rvConnectString)
{
	int nResultCode;
	char szLine[1024];
		
	// Send "authinfo user xxx"
	sprintf(szLine, "authinfo user %s\r\n", m_Settings.m_szUsername);
		
	TRACE1("Sending User Authentication: %s", szLine);

	if(!NNTP_SendLine(szLine))
	{
		strcpy(rvConnectString, "Error Sending Authentication Command (User) To Server");
		NNTP_DisconnectServer();
		return(FALSE);
	}

	TRACE("Getting User Authentication Response\n");
	szLine[0] = '\0';

	if(!NNTP_GetLine(szLine, 1023))
	{
		strcpy(rvConnectString, "Error Receiving Authentication Response (User) From Server");
		NNTP_DisconnectServer();
		return(FALSE);
	}

	TRACE1("User Authentication Response: %s", szLine);

	nResultCode = atoi(szLine);

	if(nResultCode != 381)
	{
		strcpy(rvConnectString, "Error Submitting Authentication (User) To Server:\n");
		strcat(rvConnectString, szLine);
		NNTP_DisconnectServer();
		return(FALSE);
	}
		
	// Send "authinfo pass xxxx"
	sprintf(szLine, "authinfo pass %s\r\n", m_Settings.m_szPassword);

	TRACE1("Sending Pass Authentication: %s", szLine);

	if(!NNTP_SendLine(szLine))
	{
		strcpy(rvConnectString, "Error Sending Authentication Command (Password) To Server");
		NNTP_DisconnectServer();
		return(FALSE);
	}

	TRACE("Getting User Authentication Response\n");
	szLine[0] = '\0';

	if(!NNTP_GetLine(szLine, 1023))
	{
		strcpy(rvConnectString, "Error Receiving Authentication Response (Password) From Server");
		NNTP_DisconnectServer();
		return(FALSE);
	}

	TRACE1("Pass Authentication Response: %s", szLine);

	nResultCode = atoi(szLine);

	if(nResultCode != 281)
	{
		strcpy(rvConnectString, "Error Submitting Authentication (Password) To Server:\n");
		strcat(rvConnectString, szLine);
		NNTP_DisconnectServer();
		return(FALSE);
	}
	return TRUE;
}

BOOL CPosterThread::NNTP_ConnectServer(char* ServerName, int nPort, char* rvConnectString)
{
	struct hostent* HostEnt;
	if((HostEnt = ::gethostbyname(ServerName)) == NULL)
	{
		strcpy(rvConnectString, "ERROR: Unable To Resolve Host Name '");
		strcat(rvConnectString, ServerName);
		strcat(rvConnectString, "'");
		return(FALSE);
	}

	struct sockaddr_in SA;
	SA.sin_family = AF_INET;
	SA.sin_port   = htons(nPort);
	memcpy(&(SA.sin_addr.s_addr), HostEnt->h_addr_list[0], 4);
	m_hSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if(m_hSocket == 0)
	{
		strcpy(rvConnectString, "ERROR: Can't Create Socket");
		return(FALSE);
	}

	char szLine[1024];

	if(connect(m_hSocket, (struct sockaddr*) &SA, sizeof(SA)) != 0)
	{
		strcpy(rvConnectString, "ERROR: Can't Connect To Server");
		return(FALSE);
	}

	if(NNTP_GetLine(szLine, 1023) == 0)
	{
		strcpy(rvConnectString, "ERROR: No Connection Response From Server");
		NNTP_DisconnectServer();
		return(FALSE);
	}

	strcpy(rvConnectString, szLine);

	// Authenticate User if required
	if(m_Settings.m_bRequireLogin == TRUE)
	{
		return Authenticate(rvConnectString);
	}
	return(TRUE);	
}

BOOL CPosterThread::NNTP_DisconnectServer()
{
	if(m_hSocket != 0)
	{
		SOCKET hSocket = m_hSocket;
		m_hSocket = 0;

		if(closesocket(hSocket) == 0)
			return TRUE;
		else
			return FALSE;
	}
	return TRUE;
}

void CPosterThread::_BreakFilename(LPCTSTR FullFilename, CString& Path, CString& File)
{
	int kk;
	int sz = strlen(FullFilename);

	Path.Empty();
	File.Empty();

	for(kk = (sz-1); kk >= 0; kk--)
		if(FullFilename[kk] == '\\') break;
	if(kk < 0)
	{
		File = FullFilename;
		return;
	}
	
	CString FullName = FullFilename;
	if(kk > 0)		Path = FullName.Left(kk+1);
	if(kk < (sz-1)) File = FullName.Right((sz-1) - kk);
	return;
}

BOOL CPosterThread::ParseServerDate(CTime& rvTime, LPCTSTR szDATE)
{
	TRACE("CPosterThread::ParseServerDate(%s)\n", szDATE);

	TCHAR szYear[8];
	TCHAR szMonth[8];
	TCHAR szDay[8];
	TCHAR szHour[8];
	TCHAR szMin[8];
	TCHAR szSec[8];

	if(strlen(szDATE) != 14) return(FALSE);

	::ZeroMemory(szYear, 8);
	::ZeroMemory(szMonth, 8);
	::ZeroMemory(szDay, 8);
	::ZeroMemory(szHour, 8);
	::ZeroMemory(szMin, 8);
	::ZeroMemory(szSec, 8);

	strncpy(szYear, &szDATE[0], (size_t) 4);
	strncpy(szMonth, &szDATE[4], (size_t) 2);
	strncpy(szDay, &szDATE[6], (size_t) 2);
	strncpy(szHour, &szDATE[8], (size_t) 2);
	strncpy(szMin, &szDATE[10], (size_t) 2);
	strncpy(szSec, &szDATE[12], (size_t) 2);

	rvTime = CTime::CTime(atoi(szYear), atoi(szMonth), atoi(szDay), atoi(szHour), atoi(szMin), atoi(szSec));
	return(TRUE);
}

